/*!-----------------------------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * monaco-kusto version: 5.3.6(undefined)
 * Released under the MIT license
 * https://https://github.com/Azure/monaco-kusto/blob/master/README.md
 *-----------------------------------------------------------------------------*/var __rest=this&&this.__rest||function(Y,d){var K={};for(var Q in Y)Object.prototype.hasOwnProperty.call(Y,Q)&&d.indexOf(Q)<0&&(K[Q]=Y[Q]);if(Y!=null&&typeof Object.getOwnPropertySymbols=="function"){var M=0;for(Q=Object.getOwnPropertySymbols(Y);M<Q.length;M++)d.indexOf(Q[M])<0&&Object.prototype.propertyIsEnumerable.call(Y,Q[M])&&(K[Q[M]]=Y[Q[M]])}return K};define("vs/language/kusto/workerManager",["require","exports"],function(Y,d){"use strict";Object.defineProperty(d,"__esModule",{value:!0}),d.WorkerManager=void 0;var K=function(){function Q(M,ie){var he=this;this._monacoInstance=M,this._defaults=ie,this._worker=null,this._idleCheckInterval=self.setInterval(function(){return he._checkIfIdle()},3e4),this._lastUsedTime=0,this._configChangeListener=this._defaults.onDidChange(function(){return he._saveStateAndStopWorker()})}return Q.prototype._stopWorker=function(){this._worker&&(this._worker.dispose(),this._worker=null),this._client=null},Q.prototype._saveStateAndStopWorker=function(){var M=this;this._worker&&this._worker.getProxy().then(function(ie){ie.getSchema().then(function(he){M._storedState={schema:he},M._stopWorker()})})},Q.prototype.dispose=function(){clearInterval(this._idleCheckInterval),this._configChangeListener.dispose(),this._stopWorker()},Q.prototype._checkIfIdle=function(){if(this._worker){var M=this._defaults.getWorkerMaxIdleTime(),ie=Date.now()-this._lastUsedTime;M>0&&ie>M&&this._saveStateAndStopWorker()}},Q.prototype._getClient=function(){var M=this;this._lastUsedTime=Date.now();var ie=this._defaults.languageSettings,he=(ie.onDidProvideCompletionItems,__rest(ie,["onDidProvideCompletionItems"]));return this._client||(this._worker=this._monacoInstance.editor.createWebWorker({moduleId:"vs/language/kusto/kustoWorker",label:"kusto",createData:{languageSettings:he,languageId:"kusto"}}),this._client=this._worker.getProxy().then(function(we){return M._storedState?we.setSchema(M._storedState.schema).then(function(){return we}):we})),this._client},Q.prototype.getLanguageServiceWorker=function(){for(var M,ie=this,he=[],we=0;we<arguments.length;we++)he[we]=arguments[we];return this._getClient().then(function($){M=$}).then(function($){return ie._worker.withSyncedResources(he)}).then(function($){return M})},Q}();d.WorkerManager=K}),define("vs/language/kusto/languageService/kustoMonarchLanguageDefinition",["require","exports"],function(Y,d){"use strict";Object.defineProperty(d,"__esModule",{value:!0}),d.KustoLanguageDefinition=void 0,d.KustoLanguageDefinition={name:"kusto",mimeTypes:["text/kusto"],displayName:"Kusto",defaultToken:"invalid",brackets:[["[","]","delimiter.square"],["(",")","delimiter.parenthesis"]],wordDefinition:/(-?\d*\.\d\w*)|([^\`\~\!\#\%\^\&\*\(\)\-\=\+\[\{\]\}\\\|\;\:\'\"\,\.\<\>\/\?\s]+)/g,promotedOperatorCommandTokens:Kusto.Data.IntelliSense.CslCommandParser.PromotedOperatorCommandTokens.slice(0),operatorCommandTokens:Kusto.Data.IntelliSense.CslCommandParser.OperatorCommandTokens.slice(0),keywords:["by","on","contains","notcontains","containscs","notcontainscs","startswith","has","matches","regex","true","false","and","or","typeof","int","string","date","datetime","time","long","real","\u200Bboolean","bool"],operators:["+","-","*","/",">","<","==","<>","<=",">=","~","!~"],builtinFunctions:["countof","bin","extentid","extract","extractjson","floor","iif","isnull","isnotnull","notnull","isempty","isnotempty","notempty","now","re2","strcat","strlen","toupper","tostring","count","cnt","sum","min","max","avg"],tokenizer:{root:[{include:"@whitespace"},{include:"@numbers"},{include:"@strings"},{include:"@dqstrings"},{include:"@literals"},{include:"@comments"},[/[;,.]/,"delimiter"],[/[()\[\]]/,"@brackets"],[/[<>=!%&+\-*/|~^]/,"operator"],[/[\w@#\-$]+/,{cases:{"@keywords":"keyword","@promotedOperatorCommandTokens":"operator.sql","@operatorCommandTokens":"keyword","@operators":"operator","@builtinFunctions":"predefined","@default":"identifier"}}]],whitespace:[[/\s+/,"white"]],comments:[["\\/\\/+.*","comment"]],numbers:[[/0[xX][0-9a-fA-F]*/,"number"],[/[$][+-]*\d*(\.\d*)?/,"number"],[/((\d+(\.\d*)?)|(\.\d+))([eE][\-+]?\d+)?/,"number"]],strings:[[/H'/,{token:"string.quote",bracket:"@open",next:"@string"}],[/h'/,{token:"string.quote",bracket:"@open",next:"@string"}],[/'/,{token:"string.quote",bracket:"@open",next:"@string"}]],string:[[/[^']+/,"string"],[/''/,"string"],[/'/,{token:"string.quote",bracket:"@close",next:"@pop"}]],dqstrings:[[/H"/,{token:"string.quote",bracket:"@open",next:"@dqstring"}],[/h"/,{token:"string.quote",bracket:"@open",next:"@dqstring"}],[/"/,{token:"string.quote",bracket:"@open",next:"@dqstring"}]],dqstring:[[/[^"]+/,"string"],[/""/,"string"],[/"/,{token:"string.quote",bracket:"@close",next:"@pop"}]],literals:[[/datetime\(\d{4}-\d{2}-\d{2}(\s+\d{2}:\d{2}(:\d{2}(\.\d{0,3})?)?)?\)/,"number"],[/time\((\d+(s(ec(onds?)?)?|m(in(utes?)?)?|h(ours?)?|d(ays?)?)|(\s*(('[^']+')|("[^"]+"))\s*))\)/,"number"],[/guid\([\da-fA-F]{8}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{4}-[\da-fA-F]{12}\)/,"number"],[/typeof\((int|string|date|datetime|time|long|real|boolean|bool)\)/,"number"]]}}}),function(Y){if(typeof module=="object"&&typeof module.exports=="object"){var d=Y(require,exports);d!==void 0&&(module.exports=d)}else typeof define=="function"&&define.amd&&define("vscode-languageserver-types/main",["require","exports"],Y)}(function(Y,d){"use strict";var K,Q,M,ie,he,we,$,re,me,Ne,ne,ye,fe,Te,Ee,Ve,et;Object.defineProperty(d,"__esModule",{value:!0}),d.TextDocument=d.EOL=d.SelectionRange=d.DocumentLink=d.FormattingOptions=d.CodeLens=d.CodeAction=d.CodeActionContext=d.CodeActionKind=d.DocumentSymbol=d.SymbolInformation=d.SymbolTag=d.SymbolKind=d.DocumentHighlight=d.DocumentHighlightKind=d.SignatureInformation=d.ParameterInformation=d.Hover=d.MarkedString=d.CompletionList=d.CompletionItem=d.InsertTextMode=d.InsertReplaceEdit=d.CompletionItemTag=d.InsertTextFormat=d.CompletionItemKind=d.MarkupContent=d.MarkupKind=d.TextDocumentItem=d.OptionalVersionedTextDocumentIdentifier=d.VersionedTextDocumentIdentifier=d.TextDocumentIdentifier=d.WorkspaceChange=d.WorkspaceEdit=d.DeleteFile=d.RenameFile=d.CreateFile=d.TextDocumentEdit=d.AnnotatedTextEdit=d.ChangeAnnotationIdentifier=d.ChangeAnnotation=d.TextEdit=d.Command=d.Diagnostic=d.CodeDescription=d.DiagnosticTag=d.DiagnosticSeverity=d.DiagnosticRelatedInformation=d.FoldingRange=d.FoldingRangeKind=d.ColorPresentation=d.ColorInformation=d.Color=d.LocationLink=d.Location=d.Range=d.Position=d.uinteger=d.integer=void 0,function(c){c.MIN_VALUE=-2147483648,c.MAX_VALUE=2147483647}(d.integer||(d.integer={})),function(c){c.MIN_VALUE=0,c.MAX_VALUE=2147483647}(K=d.uinteger||(d.uinteger={})),function(c){c.create=function(a,i){return a===Number.MAX_VALUE&&(a=K.MAX_VALUE),i===Number.MAX_VALUE&&(i=K.MAX_VALUE),{line:a,character:i}},c.is=function(a){var i=a;return m.objectLiteral(i)&&m.uinteger(i.line)&&m.uinteger(i.character)}}(Q=d.Position||(d.Position={})),function(c){c.create=function(a,i,h,_){if(m.uinteger(a)&&m.uinteger(i)&&m.uinteger(h)&&m.uinteger(_))return{start:Q.create(a,i),end:Q.create(h,_)};if(Q.is(a)&&Q.is(i))return{start:a,end:i};throw new Error("Range#create called with invalid arguments["+a+", "+i+", "+h+", "+_+"]")},c.is=function(a){var i=a;return m.objectLiteral(i)&&Q.is(i.start)&&Q.is(i.end)}}(M=d.Range||(d.Range={})),function(c){c.create=function(a,i){return{uri:a,range:i}},c.is=function(a){var i=a;return m.defined(i)&&M.is(i.range)&&(m.string(i.uri)||m.undefined(i.uri))}}(ie=d.Location||(d.Location={})),function(c){c.create=function(a,i,h,_){return{targetUri:a,targetRange:i,targetSelectionRange:h,originSelectionRange:_}},c.is=function(a){var i=a;return m.defined(i)&&M.is(i.targetRange)&&m.string(i.targetUri)&&(M.is(i.targetSelectionRange)||m.undefined(i.targetSelectionRange))&&(M.is(i.originSelectionRange)||m.undefined(i.originSelectionRange))}}(d.LocationLink||(d.LocationLink={})),function(c){c.create=function(a,i,h,_){return{red:a,green:i,blue:h,alpha:_}},c.is=function(a){var i=a;return m.numberRange(i.red,0,1)&&m.numberRange(i.green,0,1)&&m.numberRange(i.blue,0,1)&&m.numberRange(i.alpha,0,1)}}(he=d.Color||(d.Color={})),function(c){c.create=function(a,i){return{range:a,color:i}},c.is=function(a){var i=a;return M.is(i.range)&&he.is(i.color)}}(d.ColorInformation||(d.ColorInformation={})),function(c){c.create=function(a,i,h){return{label:a,textEdit:i,additionalTextEdits:h}},c.is=function(a){var i=a;return m.string(i.label)&&(m.undefined(i.textEdit)||me.is(i))&&(m.undefined(i.additionalTextEdits)||m.typedArray(i.additionalTextEdits,me.is))}}(d.ColorPresentation||(d.ColorPresentation={})),function(c){c.Comment="comment",c.Imports="imports",c.Region="region"}(d.FoldingRangeKind||(d.FoldingRangeKind={})),function(c){c.create=function(a,i,h,_,w){var I={startLine:a,endLine:i};return m.defined(h)&&(I.startCharacter=h),m.defined(_)&&(I.endCharacter=_),m.defined(w)&&(I.kind=w),I},c.is=function(a){var i=a;return m.uinteger(i.startLine)&&m.uinteger(i.startLine)&&(m.undefined(i.startCharacter)||m.uinteger(i.startCharacter))&&(m.undefined(i.endCharacter)||m.uinteger(i.endCharacter))&&(m.undefined(i.kind)||m.string(i.kind))}}(d.FoldingRange||(d.FoldingRange={})),function(c){c.create=function(a,i){return{location:a,message:i}},c.is=function(a){var i=a;return m.defined(i)&&ie.is(i.location)&&m.string(i.message)}}(we=d.DiagnosticRelatedInformation||(d.DiagnosticRelatedInformation={})),function(c){c.Error=1,c.Warning=2,c.Information=3,c.Hint=4}(d.DiagnosticSeverity||(d.DiagnosticSeverity={})),function(c){c.Unnecessary=1,c.Deprecated=2}(d.DiagnosticTag||(d.DiagnosticTag={})),function(c){c.is=function(a){var i=a;return i!=null&&m.string(i.href)}}(d.CodeDescription||(d.CodeDescription={})),function(c){c.create=function(a,i,h,_,w,I){var O={range:a,message:i};return m.defined(h)&&(O.severity=h),m.defined(_)&&(O.code=_),m.defined(w)&&(O.source=w),m.defined(I)&&(O.relatedInformation=I),O},c.is=function(a){var i,h=a;return m.defined(h)&&M.is(h.range)&&m.string(h.message)&&(m.number(h.severity)||m.undefined(h.severity))&&(m.integer(h.code)||m.string(h.code)||m.undefined(h.code))&&(m.undefined(h.codeDescription)||m.string((i=h.codeDescription)===null||i===void 0?void 0:i.href))&&(m.string(h.source)||m.undefined(h.source))&&(m.undefined(h.relatedInformation)||m.typedArray(h.relatedInformation,we.is))}}($=d.Diagnostic||(d.Diagnostic={})),function(c){c.create=function(a,i){for(var h=[],_=2;_<arguments.length;_++)h[_-2]=arguments[_];var w={title:a,command:i};return m.defined(h)&&h.length>0&&(w.arguments=h),w},c.is=function(a){var i=a;return m.defined(i)&&m.string(i.title)&&m.string(i.command)}}(re=d.Command||(d.Command={})),function(c){c.replace=function(a,i){return{range:a,newText:i}},c.insert=function(a,i){return{range:{start:a,end:a},newText:i}},c.del=function(a){return{range:a,newText:""}},c.is=function(a){var i=a;return m.objectLiteral(i)&&m.string(i.newText)&&M.is(i.range)}}(me=d.TextEdit||(d.TextEdit={})),function(c){c.create=function(a,i,h){var _={label:a};return i!==void 0&&(_.needsConfirmation=i),h!==void 0&&(_.description=h),_},c.is=function(a){var i=a;return i!==void 0&&m.objectLiteral(i)&&m.string(i.label)&&(m.boolean(i.needsConfirmation)||i.needsConfirmation===void 0)&&(m.string(i.description)||i.description===void 0)}}(Ne=d.ChangeAnnotation||(d.ChangeAnnotation={})),function(c){c.is=function(a){return typeof a=="string"}}(ne=d.ChangeAnnotationIdentifier||(d.ChangeAnnotationIdentifier={})),function(c){c.replace=function(a,i,h){return{range:a,newText:i,annotationId:h}},c.insert=function(a,i,h){return{range:{start:a,end:a},newText:i,annotationId:h}},c.del=function(a,i){return{range:a,newText:"",annotationId:i}},c.is=function(a){var i=a;return me.is(i)&&(Ne.is(i.annotationId)||ne.is(i.annotationId))}}(ye=d.AnnotatedTextEdit||(d.AnnotatedTextEdit={})),function(c){c.create=function(a,i){return{textDocument:a,edits:i}},c.is=function(a){var i=a;return m.defined(i)&&ct.is(i.textDocument)&&Array.isArray(i.edits)}}(fe=d.TextDocumentEdit||(d.TextDocumentEdit={})),function(c){c.create=function(a,i,h){var _={kind:"create",uri:a};return i===void 0||i.overwrite===void 0&&i.ignoreIfExists===void 0||(_.options=i),h!==void 0&&(_.annotationId=h),_},c.is=function(a){var i=a;return i&&i.kind==="create"&&m.string(i.uri)&&(i.options===void 0||(i.options.overwrite===void 0||m.boolean(i.options.overwrite))&&(i.options.ignoreIfExists===void 0||m.boolean(i.options.ignoreIfExists)))&&(i.annotationId===void 0||ne.is(i.annotationId))}}(Te=d.CreateFile||(d.CreateFile={})),function(c){c.create=function(a,i,h,_){var w={kind:"rename",oldUri:a,newUri:i};return h===void 0||h.overwrite===void 0&&h.ignoreIfExists===void 0||(w.options=h),_!==void 0&&(w.annotationId=_),w},c.is=function(a){var i=a;return i&&i.kind==="rename"&&m.string(i.oldUri)&&m.string(i.newUri)&&(i.options===void 0||(i.options.overwrite===void 0||m.boolean(i.options.overwrite))&&(i.options.ignoreIfExists===void 0||m.boolean(i.options.ignoreIfExists)))&&(i.annotationId===void 0||ne.is(i.annotationId))}}(Ee=d.RenameFile||(d.RenameFile={})),function(c){c.create=function(a,i,h){var _={kind:"delete",uri:a};return i===void 0||i.recursive===void 0&&i.ignoreIfNotExists===void 0||(_.options=i),h!==void 0&&(_.annotationId=h),_},c.is=function(a){var i=a;return i&&i.kind==="delete"&&m.string(i.uri)&&(i.options===void 0||(i.options.recursive===void 0||m.boolean(i.options.recursive))&&(i.options.ignoreIfNotExists===void 0||m.boolean(i.options.ignoreIfNotExists)))&&(i.annotationId===void 0||ne.is(i.annotationId))}}(Ve=d.DeleteFile||(d.DeleteFile={})),function(c){c.is=function(a){var i=a;return i&&(i.changes!==void 0||i.documentChanges!==void 0)&&(i.documentChanges===void 0||i.documentChanges.every(function(h){return m.string(h.kind)?Te.is(h)||Ee.is(h)||Ve.is(h):fe.is(h)}))}}(et=d.WorkspaceEdit||(d.WorkspaceEdit={}));var ct,Ce,Fe,tt,He=function(){function c(a,i){this.edits=a,this.changeAnnotations=i}return c.prototype.insert=function(a,i,h){var _,w;if(h===void 0?_=me.insert(a,i):ne.is(h)?(w=h,_=ye.insert(a,i,h)):(this.assertChangeAnnotations(this.changeAnnotations),w=this.changeAnnotations.manage(h),_=ye.insert(a,i,w)),this.edits.push(_),w!==void 0)return w},c.prototype.replace=function(a,i,h){var _,w;if(h===void 0?_=me.replace(a,i):ne.is(h)?(w=h,_=ye.replace(a,i,h)):(this.assertChangeAnnotations(this.changeAnnotations),w=this.changeAnnotations.manage(h),_=ye.replace(a,i,w)),this.edits.push(_),w!==void 0)return w},c.prototype.delete=function(a,i){var h,_;if(i===void 0?h=me.del(a):ne.is(i)?(_=i,h=ye.del(a,i)):(this.assertChangeAnnotations(this.changeAnnotations),_=this.changeAnnotations.manage(i),h=ye.del(a,_)),this.edits.push(h),_!==void 0)return _},c.prototype.add=function(a){this.edits.push(a)},c.prototype.all=function(){return this.edits},c.prototype.clear=function(){this.edits.splice(0,this.edits.length)},c.prototype.assertChangeAnnotations=function(a){if(a===void 0)throw new Error("Text edit change is not configured to manage change annotations.")},c}(),rt=function(){function c(a){this._annotations=a===void 0?Object.create(null):a,this._counter=0,this._size=0}return c.prototype.all=function(){return this._annotations},Object.defineProperty(c.prototype,"size",{get:function(){return this._size},enumerable:!1,configurable:!0}),c.prototype.manage=function(a,i){var h;if(ne.is(a)?h=a:(h=this.nextId(),i=a),this._annotations[h]!==void 0)throw new Error("Id "+h+" is already in use.");if(i===void 0)throw new Error("No annotation provided for id "+h);return this._annotations[h]=i,this._size++,h},c.prototype.nextId=function(){return this._counter++,this._counter.toString()},c}(),nt=function(){function c(a){var i=this;this._textEditChanges=Object.create(null),a!==void 0?(this._workspaceEdit=a,a.documentChanges?(this._changeAnnotations=new rt(a.changeAnnotations),a.changeAnnotations=this._changeAnnotations.all(),a.documentChanges.forEach(function(h){if(fe.is(h)){var _=new He(h.edits,i._changeAnnotations);i._textEditChanges[h.textDocument.uri]=_}})):a.changes&&Object.keys(a.changes).forEach(function(h){var _=new He(a.changes[h]);i._textEditChanges[h]=_})):this._workspaceEdit={}}return Object.defineProperty(c.prototype,"edit",{get:function(){return this.initDocumentChanges(),this._changeAnnotations!==void 0&&(this._changeAnnotations.size===0?this._workspaceEdit.changeAnnotations=void 0:this._workspaceEdit.changeAnnotations=this._changeAnnotations.all()),this._workspaceEdit},enumerable:!1,configurable:!0}),c.prototype.getTextEditChange=function(a){if(ct.is(a)){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var i={uri:a.uri,version:a.version};if(!(_=this._textEditChanges[i.uri])){var h={textDocument:i,edits:w=[]};this._workspaceEdit.documentChanges.push(h),_=new He(w,this._changeAnnotations),this._textEditChanges[i.uri]=_}return _}if(this.initChanges(),this._workspaceEdit.changes===void 0)throw new Error("Workspace edit is not configured for normal text edit changes.");var _;if(!(_=this._textEditChanges[a])){var w=[];this._workspaceEdit.changes[a]=w,_=new He(w),this._textEditChanges[a]=_}return _},c.prototype.initDocumentChanges=function(){this._workspaceEdit.documentChanges===void 0&&this._workspaceEdit.changes===void 0&&(this._changeAnnotations=new rt,this._workspaceEdit.documentChanges=[],this._workspaceEdit.changeAnnotations=this._changeAnnotations.all())},c.prototype.initChanges=function(){this._workspaceEdit.documentChanges===void 0&&this._workspaceEdit.changes===void 0&&(this._workspaceEdit.changes=Object.create(null))},c.prototype.createFile=function(a,i,h){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var _,w,I;if(Ne.is(i)||ne.is(i)?_=i:h=i,_===void 0?w=Te.create(a,h):(I=ne.is(_)?_:this._changeAnnotations.manage(_),w=Te.create(a,h,I)),this._workspaceEdit.documentChanges.push(w),I!==void 0)return I},c.prototype.renameFile=function(a,i,h,_){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var w,I,O;if(Ne.is(h)||ne.is(h)?w=h:_=h,w===void 0?I=Ee.create(a,i,_):(O=ne.is(w)?w:this._changeAnnotations.manage(w),I=Ee.create(a,i,_,O)),this._workspaceEdit.documentChanges.push(I),O!==void 0)return O},c.prototype.deleteFile=function(a,i,h){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var _,w,I;if(Ne.is(i)||ne.is(i)?_=i:h=i,_===void 0?w=Ve.create(a,h):(I=ne.is(_)?_:this._changeAnnotations.manage(_),w=Ve.create(a,h,I)),this._workspaceEdit.documentChanges.push(w),I!==void 0)return I},c}();d.WorkspaceChange=nt,function(c){c.create=function(a){return{uri:a}},c.is=function(a){var i=a;return m.defined(i)&&m.string(i.uri)}}(d.TextDocumentIdentifier||(d.TextDocumentIdentifier={})),function(c){c.create=function(a,i){return{uri:a,version:i}},c.is=function(a){var i=a;return m.defined(i)&&m.string(i.uri)&&m.integer(i.version)}}(d.VersionedTextDocumentIdentifier||(d.VersionedTextDocumentIdentifier={})),function(c){c.create=function(a,i){return{uri:a,version:i}},c.is=function(a){var i=a;return m.defined(i)&&m.string(i.uri)&&(i.version===null||m.integer(i.version))}}(ct=d.OptionalVersionedTextDocumentIdentifier||(d.OptionalVersionedTextDocumentIdentifier={})),function(c){c.create=function(a,i,h,_){return{uri:a,languageId:i,version:h,text:_}},c.is=function(a){var i=a;return m.defined(i)&&m.string(i.uri)&&m.string(i.languageId)&&m.integer(i.version)&&m.string(i.text)}}(d.TextDocumentItem||(d.TextDocumentItem={})),function(c){c.PlainText="plaintext",c.Markdown="markdown"}(Ce=d.MarkupKind||(d.MarkupKind={})),function(c){c.is=function(a){var i=a;return i===c.PlainText||i===c.Markdown}}(Ce=d.MarkupKind||(d.MarkupKind={})),function(c){c.is=function(a){var i=a;return m.objectLiteral(a)&&Ce.is(i.kind)&&m.string(i.value)}}(Fe=d.MarkupContent||(d.MarkupContent={})),function(c){c.Text=1,c.Method=2,c.Function=3,c.Constructor=4,c.Field=5,c.Variable=6,c.Class=7,c.Interface=8,c.Module=9,c.Property=10,c.Unit=11,c.Value=12,c.Enum=13,c.Keyword=14,c.Snippet=15,c.Color=16,c.File=17,c.Reference=18,c.Folder=19,c.EnumMember=20,c.Constant=21,c.Struct=22,c.Event=23,c.Operator=24,c.TypeParameter=25}(d.CompletionItemKind||(d.CompletionItemKind={})),function(c){c.PlainText=1,c.Snippet=2}(d.InsertTextFormat||(d.InsertTextFormat={})),function(c){c.Deprecated=1}(d.CompletionItemTag||(d.CompletionItemTag={})),function(c){c.create=function(a,i,h){return{newText:a,insert:i,replace:h}},c.is=function(a){var i=a;return i&&m.string(i.newText)&&M.is(i.insert)&&M.is(i.replace)}}(d.InsertReplaceEdit||(d.InsertReplaceEdit={})),function(c){c.asIs=1,c.adjustIndentation=2}(d.InsertTextMode||(d.InsertTextMode={})),function(c){c.create=function(a){return{label:a}}}(d.CompletionItem||(d.CompletionItem={})),function(c){c.create=function(a,i){return{items:a||[],isIncomplete:!!i}}}(d.CompletionList||(d.CompletionList={})),function(c){c.fromPlainText=function(a){return a.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")},c.is=function(a){var i=a;return m.string(i)||m.objectLiteral(i)&&m.string(i.language)&&m.string(i.value)}}(tt=d.MarkedString||(d.MarkedString={})),function(c){c.is=function(a){var i=a;return!!i&&m.objectLiteral(i)&&(Fe.is(i.contents)||tt.is(i.contents)||m.typedArray(i.contents,tt.is))&&(a.range===void 0||M.is(a.range))}}(d.Hover||(d.Hover={})),function(c){c.create=function(a,i){return i?{label:a,documentation:i}:{label:a}}}(d.ParameterInformation||(d.ParameterInformation={})),function(c){c.create=function(a,i){for(var h=[],_=2;_<arguments.length;_++)h[_-2]=arguments[_];var w={label:a};return m.defined(i)&&(w.documentation=i),m.defined(h)?w.parameters=h:w.parameters=[],w}}(d.SignatureInformation||(d.SignatureInformation={})),function(c){c.Text=1,c.Read=2,c.Write=3}(d.DocumentHighlightKind||(d.DocumentHighlightKind={})),function(c){c.create=function(a,i){var h={range:a};return m.number(i)&&(h.kind=i),h}}(d.DocumentHighlight||(d.DocumentHighlight={})),function(c){c.File=1,c.Module=2,c.Namespace=3,c.Package=4,c.Class=5,c.Method=6,c.Property=7,c.Field=8,c.Constructor=9,c.Enum=10,c.Interface=11,c.Function=12,c.Variable=13,c.Constant=14,c.String=15,c.Number=16,c.Boolean=17,c.Array=18,c.Object=19,c.Key=20,c.Null=21,c.EnumMember=22,c.Struct=23,c.Event=24,c.Operator=25,c.TypeParameter=26}(d.SymbolKind||(d.SymbolKind={})),function(c){c.Deprecated=1}(d.SymbolTag||(d.SymbolTag={})),function(c){c.create=function(a,i,h,_,w){var I={name:a,kind:i,location:{uri:_,range:h}};return w&&(I.containerName=w),I}}(d.SymbolInformation||(d.SymbolInformation={})),function(c){c.create=function(a,i,h,_,w,I){var O={name:a,detail:i,kind:h,range:_,selectionRange:w};return I!==void 0&&(O.children=I),O},c.is=function(a){var i=a;return i&&m.string(i.name)&&m.number(i.kind)&&M.is(i.range)&&M.is(i.selectionRange)&&(i.detail===void 0||m.string(i.detail))&&(i.deprecated===void 0||m.boolean(i.deprecated))&&(i.children===void 0||Array.isArray(i.children))&&(i.tags===void 0||Array.isArray(i.tags))}}(d.DocumentSymbol||(d.DocumentSymbol={})),function(c){c.Empty="",c.QuickFix="quickfix",c.Refactor="refactor",c.RefactorExtract="refactor.extract",c.RefactorInline="refactor.inline",c.RefactorRewrite="refactor.rewrite",c.Source="source",c.SourceOrganizeImports="source.organizeImports",c.SourceFixAll="source.fixAll"}(d.CodeActionKind||(d.CodeActionKind={})),function(c){c.create=function(a,i){var h={diagnostics:a};return i!=null&&(h.only=i),h},c.is=function(a){var i=a;return m.defined(i)&&m.typedArray(i.diagnostics,$.is)&&(i.only===void 0||m.typedArray(i.only,m.string))}}(d.CodeActionContext||(d.CodeActionContext={})),function(c){c.create=function(a,i,h){var _={title:a},w=!0;return typeof i=="string"?(w=!1,_.kind=i):re.is(i)?_.command=i:_.edit=i,w&&h!==void 0&&(_.kind=h),_},c.is=function(a){var i=a;return i&&m.string(i.title)&&(i.diagnostics===void 0||m.typedArray(i.diagnostics,$.is))&&(i.kind===void 0||m.string(i.kind))&&(i.edit!==void 0||i.command!==void 0)&&(i.command===void 0||re.is(i.command))&&(i.isPreferred===void 0||m.boolean(i.isPreferred))&&(i.edit===void 0||et.is(i.edit))}}(d.CodeAction||(d.CodeAction={})),function(c){c.create=function(a,i){var h={range:a};return m.defined(i)&&(h.data=i),h},c.is=function(a){var i=a;return m.defined(i)&&M.is(i.range)&&(m.undefined(i.command)||re.is(i.command))}}(d.CodeLens||(d.CodeLens={})),function(c){c.create=function(a,i){return{tabSize:a,insertSpaces:i}},c.is=function(a){var i=a;return m.defined(i)&&m.uinteger(i.tabSize)&&m.boolean(i.insertSpaces)}}(d.FormattingOptions||(d.FormattingOptions={})),function(c){c.create=function(a,i,h){return{range:a,target:i,data:h}},c.is=function(a){var i=a;return m.defined(i)&&M.is(i.range)&&(m.undefined(i.target)||m.string(i.target))}}(d.DocumentLink||(d.DocumentLink={})),function(c){c.create=function(a,i){return{range:a,parent:i}},c.is=function(a){var i=a;return i!==void 0&&M.is(i.range)&&(i.parent===void 0||c.is(i.parent))}}(d.SelectionRange||(d.SelectionRange={})),d.EOL=[`
`,`\r
`,"\r"],function(c){c.create=function(a,i,h,_){return new Ot(a,i,h,_)},c.is=function(a){var i=a;return!!(m.defined(i)&&m.string(i.uri)&&(m.undefined(i.languageId)||m.string(i.languageId))&&m.uinteger(i.lineCount)&&m.func(i.getText)&&m.func(i.positionAt)&&m.func(i.offsetAt))},c.applyEdits=function(a,i){for(var h=a.getText(),_=function q(E,S){if(E.length<=1)return E;var J=E.length/2|0,ee=E.slice(0,J),f=E.slice(J);q(ee,S),q(f,S);for(var G=0,ce=0,Ie=0;G<ee.length&&ce<f.length;){var qe=S(ee[G],f[ce]);E[Ie++]=qe<=0?ee[G++]:f[ce++]}for(;G<ee.length;)E[Ie++]=ee[G++];for(;ce<f.length;)E[Ie++]=f[ce++];return E}(i,function(q,E){var S=q.range.start.line-E.range.start.line;return S===0?q.range.start.character-E.range.start.character:S}),w=h.length,I=_.length-1;I>=0;I--){var O=_[I],ue=a.offsetAt(O.range.start),P=a.offsetAt(O.range.end);if(!(P<=w))throw new Error("Overlapping edit");h=h.substring(0,ue)+O.newText+h.substring(P,h.length),w=ue}return h}}(d.TextDocument||(d.TextDocument={}));var m,Ot=function(){function c(a,i,h,_){this._uri=a,this._languageId=i,this._version=h,this._content=_,this._lineOffsets=void 0}return Object.defineProperty(c.prototype,"uri",{get:function(){return this._uri},enumerable:!1,configurable:!0}),Object.defineProperty(c.prototype,"languageId",{get:function(){return this._languageId},enumerable:!1,configurable:!0}),Object.defineProperty(c.prototype,"version",{get:function(){return this._version},enumerable:!1,configurable:!0}),c.prototype.getText=function(a){if(a){var i=this.offsetAt(a.start),h=this.offsetAt(a.end);return this._content.substring(i,h)}return this._content},c.prototype.update=function(a,i){this._content=a.text,this._version=i,this._lineOffsets=void 0},c.prototype.getLineOffsets=function(){if(this._lineOffsets===void 0){for(var a=[],i=this._content,h=!0,_=0;_<i.length;_++){h&&(a.push(_),h=!1);var w=i.charAt(_);h=w==="\r"||w===`
`,w==="\r"&&_+1<i.length&&i.charAt(_+1)===`
`&&_++}h&&i.length>0&&a.push(i.length),this._lineOffsets=a}return this._lineOffsets},c.prototype.positionAt=function(a){a=Math.max(Math.min(a,this._content.length),0);var i=this.getLineOffsets(),h=0,_=i.length;if(_===0)return Q.create(0,a);for(;h<_;){var w=Math.floor((h+_)/2);i[w]>a?_=w:h=w+1}var I=h-1;return Q.create(I,a-i[I])},c.prototype.offsetAt=function(a){var i=this.getLineOffsets();if(a.line>=i.length)return this._content.length;if(a.line<0)return 0;var h=i[a.line],_=a.line+1<i.length?i[a.line+1]:this._content.length;return Math.max(Math.min(h+a.character,_),h)},Object.defineProperty(c.prototype,"lineCount",{get:function(){return this.getLineOffsets().length},enumerable:!1,configurable:!0}),c}();(function(c){var a=Object.prototype.toString;c.defined=function(i){return i!==void 0},c.undefined=function(i){return i===void 0},c.boolean=function(i){return i===!0||i===!1},c.string=function(i){return a.call(i)==="[object String]"},c.number=function(i){return a.call(i)==="[object Number]"},c.numberRange=function(i,h,_){return a.call(i)==="[object Number]"&&h<=i&&i<=_},c.integer=function(i){return a.call(i)==="[object Number]"&&-2147483648<=i&&i<=2147483647},c.uinteger=function(i){return a.call(i)==="[object Number]"&&0<=i&&i<=2147483647},c.func=function(i){return a.call(i)==="[object Function]"},c.objectLiteral=function(i){return i!==null&&typeof i=="object"},c.typedArray=function(i,h){return Array.isArray(i)&&i.every(h)}})(m||(m={}))}),define("vscode-languageserver-types",["vscode-languageserver-types/main"],function(Y){return Y}),function(){function Y(v,k,o){switch(o.length){case 0:return v.call(k);case 1:return v.call(k,o[0]);case 2:return v.call(k,o[0],o[1]);case 3:return v.call(k,o[0],o[1],o[2])}return v.apply(k,o)}function d(v,k,o,F){for(var z=-1,T=v==null?0:v.length;++z<T;){var ge=v[z];k(F,ge,o(ge),v)}return F}function K(v,k){for(var o=-1,F=v==null?0:v.length;++o<F&&k(v[o],o,v)!==!1;);return v}function Q(v,k){for(var o=v==null?0:v.length;o--&&k(v[o],o,v)!==!1;);return v}function M(v,k){for(var o=-1,F=v==null?0:v.length;++o<F;)if(!k(v[o],o,v))return!1;return!0}function ie(v,k){for(var o=-1,F=v==null?0:v.length,z=0,T=[];++o<F;){var ge=v[o];k(ge,o,v)&&(T[z++]=ge)}return T}function he(v,k){return!(v==null||!v.length)&&Ee(v,k,0)>-1}function we(v,k,o){for(var F=-1,z=v==null?0:v.length;++F<z;)if(o(k,v[F]))return!0;return!1}function $(v,k){for(var o=-1,F=v==null?0:v.length,z=Array(F);++o<F;)z[o]=k(v[o],o,v);return z}function re(v,k){for(var o=-1,F=k.length,z=v.length;++o<F;)v[z+o]=k[o];return v}function me(v,k,o,F){var z=-1,T=v==null?0:v.length;for(F&&T&&(o=v[++z]);++z<T;)o=k(o,v[z],z,v);return o}function Ne(v,k,o,F){var z=v==null?0:v.length;for(F&&z&&(o=v[--z]);z--;)o=k(o,v[z],z,v);return o}function ne(v,k){for(var o=-1,F=v==null?0:v.length;++o<F;)if(k(v[o],o,v))return!0;return!1}function ye(v){return v.match(ya)||[]}function fe(v,k,o){var F;return o(v,function(z,T,ge){if(k(z,T,ge))return F=T,!1}),F}function Te(v,k,o,F){for(var z=v.length,T=o+(F?1:-1);F?T--:++T<z;)if(k(v[T],T,v))return T;return-1}function Ee(v,k,o){return k==k?function(F,z,T){for(var ge=T-1,Be=F.length;++ge<Be;)if(F[ge]===z)return ge;return-1}(v,k,o):Te(v,et,o)}function Ve(v,k,o,F){for(var z=o-1,T=v.length;++z<T;)if(F(v[z],k))return z;return-1}function et(v){return v!=v}function ct(v,k){var o=v==null?0:v.length;return o?He(v,k)/o:Bt}function Ce(v){return function(k){return k==null?f:k[v]}}function Fe(v){return function(k){return v==null?f:v[k]}}function tt(v,k,o,F,z){return z(v,function(T,ge,Be){o=F?(F=!1,T):k(o,T,ge,Be)}),o}function He(v,k){for(var o,F=-1,z=v.length;++F<z;){var T=k(v[F]);T!==f&&(o=o===f?T:o+T)}return o}function rt(v,k){for(var o=-1,F=Array(v);++o<v;)F[o]=k(o);return F}function nt(v){return v&&v.slice(0,J(v)+1).replace(jn,"")}function m(v){return function(k){return v(k)}}function Ot(v,k){return $(k,function(o){return v[o]})}function c(v,k){return v.has(k)}function a(v,k){for(var o=-1,F=v.length;++o<F&&Ee(k,v[o],0)>-1;);return o}function i(v,k){for(var o=v.length;o--&&Ee(k,v[o],0)>-1;);return o}function h(v,k){for(var o=v.length,F=0;o--;)v[o]===k&&++F;return F}function _(v){return"\\"+qa[v]}function w(v){return Wa.test(v)}function I(v){return Ka.test(v)}function O(v){var k=-1,o=Array(v.size);return v.forEach(function(F,z){o[++k]=[z,F]}),o}function ue(v,k){return function(o){return v(k(o))}}function P(v,k){for(var o=-1,F=v.length,z=0,T=[];++o<F;){var ge=v[o];ge!==k&&ge!==Ie||(v[o]=Ie,T[z++]=o)}return T}function q(v){var k=-1,o=Array(v.size);return v.forEach(function(F){o[++k]=F}),o}function E(v){return w(v)?function(k){for(var o=Fn.lastIndex=0;Fn.test(k);)++o;return o}(v):Ha(v)}function S(v){return w(v)?function(k){return k.match(Fn)||[]}(v):function(k){return k.split("")}(v)}function J(v){for(var k=v.length;k--&&pa.test(v.charAt(k)););return k}function ee(v){return v.match(za)||[]}var f,G="Expected a function",ce="__lodash_hash_undefined__",Ie="__lodash_placeholder__",qe=128,st=9007199254740991,Bt=NaN,Ct=4294967295,na=[["ary",qe],["bind",1],["bindKey",2],["curry",8],["curryRight",16],["flip",512],["partial",32],["partialRight",64],["rearg",256]],$t="[object Arguments]",Sr="[object Array]",or="[object Boolean]",ur="[object Date]",Er="[object Error]",Dr="[object Function]",Mi="[object GeneratorFunction]",it="[object Map]",ar="[object Number]",pt="[object Object]",Fi="[object Promise]",cr="[object RegExp]",ot="[object Set]",sr="[object String]",Lr="[object Symbol]",fr="[object WeakMap]",lr="[object ArrayBuffer]",Ut="[object DataView]",kn="[object Float32Array]",xn="[object Float64Array]",Cn="[object Int8Array]",In="[object Int16Array]",An="[object Int32Array]",Sn="[object Uint8Array]",En="[object Uint8ClampedArray]",Dn="[object Uint16Array]",Ln="[object Uint32Array]",ia=/\b__p \+= '';/g,oa=/\b(__p \+=) '' \+/g,ua=/(__e\(.*?\)|\b__t\)) \+\n'';/g,Pi=/&(?:amp|lt|gt|quot|#39);/g,zi=/[&<>"']/g,aa=RegExp(Pi.source),ca=RegExp(zi.source),sa=/<%-([\s\S]+?)%>/g,fa=/<%([\s\S]+?)%>/g,Wi=/<%=([\s\S]+?)%>/g,la=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,da=/^\w*$/,ga=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g,Tn=/[\\^$.*+?()[\]{}|]/g,ha=RegExp(Tn.source),jn=/^\s+/,pa=/\s/,va=/\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/,_a=/\{\n\/\* \[wrapped with (.+)\] \*/,ma=/,? & /,ya=/[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g,ba=/[()=,{}\[\]\/\s]/,wa=/\\(\\)?/g,ka=/\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g,Ki=/\w*$/,xa=/^[-+]0x[0-9a-f]+$/i,Ca=/^0b[01]+$/i,Ia=/^\[object .+?Constructor\]$/,Aa=/^0o[0-7]+$/i,Sa=/^(?:0|[1-9]\d*)$/,Ea=/[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g,Tr=/($^)/,Da=/['\n\r\u2028\u2029\\]/g,jr="\\ud800-\\udfff",Ni="\\u0300-\\u036f\\ufe20-\\ufe2f\\u20d0-\\u20ff",Vi="\\u2700-\\u27bf",qi="a-z\\xdf-\\xf6\\xf8-\\xff",Bi="A-Z\\xc0-\\xd6\\xd8-\\xde",$i="\\ufe0e\\ufe0f",Ui="\\xac\\xb1\\xd7\\xf7\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf\\u2000-\\u206f \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000",La="['\u2019]",Ta="["+jr+"]",Hi="["+Ui+"]",Or="["+Ni+"]",Zi="\\d+",ja="["+Vi+"]",Gi="["+qi+"]",Xi="[^"+jr+Ui+Zi+Vi+qi+Bi+"]",On="\\ud83c[\\udffb-\\udfff]",Qi="[^"+jr+"]",Rn="(?:\\ud83c[\\udde6-\\uddff]){2}",Mn="[\\ud800-\\udbff][\\udc00-\\udfff]",Ht="["+Bi+"]",Yi="(?:"+Gi+"|"+Xi+")",Oa="(?:"+Ht+"|"+Xi+")",Ji="(?:['\u2019](?:d|ll|m|re|s|t|ve))?",eo="(?:['\u2019](?:D|LL|M|RE|S|T|VE))?",to="(?:"+Or+"|"+On+")?",ro="["+$i+"]?",no=ro+to+("(?:\\u200d(?:"+[Qi,Rn,Mn].join("|")+")"+ro+to+")*"),Ra="(?:"+[ja,Rn,Mn].join("|")+")"+no,Ma="(?:"+[Qi+Or+"?",Or,Rn,Mn,Ta].join("|")+")",Fa=RegExp(La,"g"),Pa=RegExp(Or,"g"),Fn=RegExp(On+"(?="+On+")|"+Ma+no,"g"),za=RegExp([Ht+"?"+Gi+"+"+Ji+"(?="+[Hi,Ht,"$"].join("|")+")",Oa+"+"+eo+"(?="+[Hi,Ht+Yi,"$"].join("|")+")",Ht+"?"+Yi+"+"+Ji,Ht+"+"+eo,"\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])","\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])",Zi,Ra].join("|"),"g"),Wa=RegExp("[\\u200d"+jr+Ni+$i+"]"),Ka=/[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/,Na=["Array","Buffer","DataView","Date","Error","Float32Array","Float64Array","Function","Int8Array","Int16Array","Int32Array","Map","Math","Object","Promise","RegExp","Set","String","Symbol","TypeError","Uint8Array","Uint8ClampedArray","Uint16Array","Uint32Array","WeakMap","_","clearTimeout","isFinite","parseInt","setTimeout"],Va=-1,le={};le[kn]=le[xn]=le[Cn]=le[In]=le[An]=le[Sn]=le[En]=le[Dn]=le[Ln]=!0,le[$t]=le[Sr]=le[lr]=le[or]=le[Ut]=le[ur]=le[Er]=le[Dr]=le[it]=le[ar]=le[pt]=le[cr]=le[ot]=le[sr]=le[fr]=!1;var se={};se[$t]=se[Sr]=se[lr]=se[Ut]=se[or]=se[ur]=se[kn]=se[xn]=se[Cn]=se[In]=se[An]=se[it]=se[ar]=se[pt]=se[cr]=se[ot]=se[sr]=se[Lr]=se[Sn]=se[En]=se[Dn]=se[Ln]=!0,se[Er]=se[Dr]=se[fr]=!1;var qa={"\\":"\\","'":"'","\n":"n","\r":"r","\u2028":"u2028","\u2029":"u2029"},Ba=parseFloat,$a=parseInt,io=typeof global=="object"&&global&&global.Object===Object&&global,Ua=typeof self=="object"&&self&&self.Object===Object&&self,Ae=io||Ua||Function("return this")(),Pn=typeof exports=="object"&&exports&&!exports.nodeType&&exports,Rt=Pn&&typeof module=="object"&&module&&!module.nodeType&&module,oo=Rt&&Rt.exports===Pn,zn=oo&&io.process,Ze=function(){try{var v=Rt&&Rt.require&&Rt.require("util").types;return v||zn&&zn.binding&&zn.binding("util")}catch{}}(),uo=Ze&&Ze.isArrayBuffer,ao=Ze&&Ze.isDate,co=Ze&&Ze.isMap,so=Ze&&Ze.isRegExp,fo=Ze&&Ze.isSet,lo=Ze&&Ze.isTypedArray,Ha=Ce("length"),Za=Fe({\u00C0:"A",\u00C1:"A",\u00C2:"A",\u00C3:"A",\u00C4:"A",\u00C5:"A",\u00E0:"a",\u00E1:"a",\u00E2:"a",\u00E3:"a",\u00E4:"a",\u00E5:"a",\u00C7:"C",\u00E7:"c",\u00D0:"D",\u00F0:"d",\u00C8:"E",\u00C9:"E",\u00CA:"E",\u00CB:"E",\u00E8:"e",\u00E9:"e",\u00EA:"e",\u00EB:"e",\u00CC:"I",\u00CD:"I",\u00CE:"I",\u00CF:"I",\u00EC:"i",\u00ED:"i",\u00EE:"i",\u00EF:"i",\u00D1:"N",\u00F1:"n",\u00D2:"O",\u00D3:"O",\u00D4:"O",\u00D5:"O",\u00D6:"O",\u00D8:"O",\u00F2:"o",\u00F3:"o",\u00F4:"o",\u00F5:"o",\u00F6:"o",\u00F8:"o",\u00D9:"U",\u00DA:"U",\u00DB:"U",\u00DC:"U",\u00F9:"u",\u00FA:"u",\u00FB:"u",\u00FC:"u",\u00DD:"Y",\u00FD:"y",\u00FF:"y",\u00C6:"Ae",\u00E6:"ae",\u00DE:"Th",\u00FE:"th",\u00DF:"ss",\u0100:"A",\u0102:"A",\u0104:"A",\u0101:"a",\u0103:"a",\u0105:"a",\u0106:"C",\u0108:"C",\u010A:"C",\u010C:"C",\u0107:"c",\u0109:"c",\u010B:"c",\u010D:"c",\u010E:"D",\u0110:"D",\u010F:"d",\u0111:"d",\u0112:"E",\u0114:"E",\u0116:"E",\u0118:"E",\u011A:"E",\u0113:"e",\u0115:"e",\u0117:"e",\u0119:"e",\u011B:"e",\u011C:"G",\u011E:"G",\u0120:"G",\u0122:"G",\u011D:"g",\u011F:"g",\u0121:"g",\u0123:"g",\u0124:"H",\u0126:"H",\u0125:"h",\u0127:"h",\u0128:"I",\u012A:"I",\u012C:"I",\u012E:"I",\u0130:"I",\u0129:"i",\u012B:"i",\u012D:"i",\u012F:"i",\u0131:"i",\u0134:"J",\u0135:"j",\u0136:"K",\u0137:"k",\u0138:"k",\u0139:"L",\u013B:"L",\u013D:"L",\u013F:"L",\u0141:"L",\u013A:"l",\u013C:"l",\u013E:"l",\u0140:"l",\u0142:"l",\u0143:"N",\u0145:"N",\u0147:"N",\u014A:"N",\u0144:"n",\u0146:"n",\u0148:"n",\u014B:"n",\u014C:"O",\u014E:"O",\u0150:"O",\u014D:"o",\u014F:"o",\u0151:"o",\u0154:"R",\u0156:"R",\u0158:"R",\u0155:"r",\u0157:"r",\u0159:"r",\u015A:"S",\u015C:"S",\u015E:"S",\u0160:"S",\u015B:"s",\u015D:"s",\u015F:"s",\u0161:"s",\u0162:"T",\u0164:"T",\u0166:"T",\u0163:"t",\u0165:"t",\u0167:"t",\u0168:"U",\u016A:"U",\u016C:"U",\u016E:"U",\u0170:"U",\u0172:"U",\u0169:"u",\u016B:"u",\u016D:"u",\u016F:"u",\u0171:"u",\u0173:"u",\u0174:"W",\u0175:"w",\u0176:"Y",\u0177:"y",\u0178:"Y",\u0179:"Z",\u017B:"Z",\u017D:"Z",\u017A:"z",\u017C:"z",\u017E:"z",\u0132:"IJ",\u0133:"ij",\u0152:"Oe",\u0153:"oe",\u0149:"'n",\u017F:"s"}),Ga=Fe({"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"}),Xa=Fe({"&amp;":"&","&lt;":"<","&gt;":">","&quot;":'"',"&#39;":"'"}),It=function v(k){function o(e){if(_e(e)&&!H(e)&&!(e instanceof T)){if(e instanceof z)return e;if(ae.call(e,"__wrapped__"))return uu(e)}return new z(e)}function F(){}function z(e,t){this.__wrapped__=e,this.__actions__=[],this.__chain__=!!t,this.__index__=0,this.__values__=f}function T(e){this.__wrapped__=e,this.__actions__=[],this.__dir__=1,this.__filtered__=!1,this.__iteratees__=[],this.__takeCount__=Ct,this.__views__=[]}function ge(e){var t=-1,r=e==null?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function Be(e){var t=-1,r=e==null?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function vt(e){var t=-1,r=e==null?0:e.length;for(this.clear();++t<r;){var n=e[t];this.set(n[0],n[1])}}function Mt(e){var t=-1,r=e==null?0:e.length;for(this.__data__=new vt;++t<r;)this.add(e[t])}function ut(e){this.size=(this.__data__=new Be(e)).size}function go(e,t){var r=H(e),n=!r&&Nt(e),u=!r&&!n&&Tt(e),s=!r&&!n&&!u&&nr(e),l=r||n||u||s,g=l?rt(e.length,hc):[],p=g.length;for(var y in e)!t&&!ae.call(e,y)||l&&(y=="length"||u&&(y=="offset"||y=="parent")||s&&(y=="buffer"||y=="byteLength"||y=="byteOffset")||bt(y,p))||g.push(y);return g}function ho(e){var t=e.length;return t?e[Zn(0,t-1)]:f}function Qa(e,t){return Hr(Pe(e),Ft(t,0,e.length))}function Ya(e){return Hr(Pe(e))}function Wn(e,t,r){(r===f||at(e[t],r))&&(r!==f||t in e)||_t(e,t,r)}function dr(e,t,r){var n=e[t];ae.call(e,t)&&at(n,r)&&(r!==f||t in e)||_t(e,t,r)}function Rr(e,t){for(var r=e.length;r--;)if(at(e[r][0],t))return r;return-1}function Ja(e,t,r,n){return Lt(e,function(u,s,l){t(n,u,r(u),l)}),n}function po(e,t){return e&&lt(t,Se(t),e)}function _t(e,t,r){t=="__proto__"&&fn?fn(e,t,{configurable:!0,enumerable:!0,value:r,writable:!0}):e[t]=r}function Kn(e,t){for(var r=-1,n=t.length,u=ke(n),s=e==null;++r<n;)u[r]=s?f:gi(e,t[r]);return u}function Ft(e,t,r){return e==e&&(r!==f&&(e=e<=r?e:r),t!==f&&(e=e>=t?e:t)),e}function Ge(e,t,r,n,u,s){var l,g=1&t,p=2&t,y=4&t;if(r&&(l=u?r(e,n,u,s):r(e)),l!==f)return l;if(!pe(e))return e;var b=H(e);if(b){if(l=function(x){var A=x.length,B=new x.constructor(A);return A&&typeof x[0]=="string"&&ae.call(x,"index")&&(B.index=x.index,B.input=x.input),B}(e),!g)return Pe(e,l)}else{var C=Oe(e),L=C==Dr||C==Mi;if(Tt(e))return Mo(e,g);if(C==pt||C==$t||L&&!u){if(l=p||L?{}:Jo(e),!g)return p?function(x,A){return lt(x,Vu(x),A)}(e,function(x,A){return x&&lt(A,We(A),x)}(l,e)):function(x,A){return lt(x,Ei(x),A)}(e,po(l,e))}else{if(!se[C])return u?e:{};l=function(x,A,B){var j=x.constructor;switch(A){case lr:return ti(x);case or:case ur:return new j(+x);case Ut:return function(W,te){return new W.constructor(te?ti(W.buffer):W.buffer,W.byteOffset,W.byteLength)}(x,B);case kn:case xn:case Cn:case In:case An:case Sn:case En:case Dn:case Ln:return Fo(x,B);case it:return new j;case ar:case sr:return new j(x);case cr:return function(W){var te=new W.constructor(W.source,Ki.exec(W));return te.lastIndex=W.lastIndex,te}(x);case ot:return new j;case Lr:return function(W){return Cr?de(Cr.call(W)):{}}(x)}}(e,C,g)}}s||(s=new ut);var D=s.get(e);if(D)return D;s.set(e,l),Zu(e)?e.forEach(function(x){l.add(Ge(x,t,r,x,e,s))}):Hu(e)&&e.forEach(function(x,A){l.set(A,Ge(x,t,r,A,e,s))});var R=b?f:(y?p?oi:ii:p?We:Se)(e);return K(R||e,function(x,A){R&&(x=e[A=x]),dr(l,A,Ge(x,t,r,A,e,s))}),l}function vo(e,t,r){var n=r.length;if(e==null)return!n;for(e=de(e);n--;){var u=r[n],s=t[u],l=e[u];if(l===f&&!(u in e)||!s(l))return!1}return!0}function _o(e,t,r){if(typeof e!="function")throw new Je(G);return Ir(function(){e.apply(f,r)},t)}function gr(e,t,r,n){var u=-1,s=he,l=!0,g=e.length,p=[],y=t.length;if(!g)return p;r&&(t=$(t,m(r))),n?(s=we,l=!1):t.length>=200&&(s=c,l=!1,t=new Mt(t));e:for(;++u<g;){var b=e[u],C=r==null?b:r(b);if(b=n||b!==0?b:0,l&&C==C){for(var L=y;L--;)if(t[L]===C)continue e;p.push(b)}else s(t,C,n)||p.push(b)}return p}function ec(e,t){var r=!0;return Lt(e,function(n,u,s){return r=!!t(n,u,s)}),r}function Mr(e,t,r){for(var n=-1,u=e.length;++n<u;){var s=e[n],l=t(s);if(l!=null&&(g===f?l==l&&!Ue(l):r(l,g)))var g=l,p=s}return p}function mo(e,t){var r=[];return Lt(e,function(n,u,s){t(n,u,s)&&r.push(n)}),r}function De(e,t,r,n,u){var s=-1,l=e.length;for(r||(r=lc),u||(u=[]);++s<l;){var g=e[s];t>0&&r(g)?t>1?De(g,t-1,r,n,u):re(u,g):n||(u[u.length]=g)}return u}function ft(e,t){return e&&Ai(e,t,Se)}function Nn(e,t){return e&&Wu(e,t,Se)}function Fr(e,t){return ie(t,function(r){return wt(e[r])})}function Pt(e,t){for(var r=0,n=(t=St(t,e)).length;e!=null&&r<n;)e=e[dt(t[r++])];return r&&r==n?e:f}function yo(e,t,r){var n=t(e);return H(e)?n:re(n,r(e))}function Re(e){return e==null?e===f?"[object Undefined]":"[object Null]":Kt&&Kt in de(e)?function(t){var r=ae.call(t,Kt),n=t[Kt];try{t[Kt]=f;var u=!0}catch{}var s=on.call(t);return u&&(r?t[Kt]=n:delete t[Kt]),s}(e):function(t){return on.call(t)}(e)}function Vn(e,t){return e>t}function tc(e,t){return e!=null&&ae.call(e,t)}function rc(e,t){return e!=null&&t in de(e)}function qn(e,t,r){for(var n=r?we:he,u=e[0].length,s=e.length,l=s,g=ke(s),p=1/0,y=[];l--;){var b=e[l];l&&t&&(b=$(b,m(t))),p=je(b.length,p),g[l]=!r&&(t||u>=120&&b.length>=120)?new Mt(l&&b):f}b=e[0];var C=-1,L=g[0];e:for(;++C<u&&y.length<p;){var D=b[C],R=t?t(D):D;if(D=r||D!==0?D:0,!(L?c(L,R):n(y,R,r))){for(l=s;--l;){var x=g[l];if(!(x?c(x,R):n(e[l],R,r)))continue e}L&&L.push(R),y.push(D)}}return y}function hr(e,t,r){var n=(e=nu(e,t=St(t,e)))==null?e:e[dt(Qe(t))];return n==null?f:Y(n,e,r)}function bo(e){return _e(e)&&Re(e)==$t}function pr(e,t,r,n,u){return e===t||(e==null||t==null||!_e(e)&&!_e(t)?e!=e&&t!=t:function(s,l,g,p,y,b){var C=H(s),L=H(l),D=C?Sr:Oe(s),R=L?Sr:Oe(l),x=(D=D==$t?pt:D)==pt,A=(R=R==$t?pt:R)==pt,B=D==R;if(B&&Tt(s)){if(!Tt(l))return!1;C=!0,x=!1}if(B&&!x)return b||(b=new ut),C||nr(s)?Qo(s,l,g,p,y,b):function(V,U,Vt,gt,ir,Le,xt){switch(Vt){case Ut:if(V.byteLength!=U.byteLength||V.byteOffset!=U.byteOffset)return!1;V=V.buffer,U=U.buffer;case lr:return!(V.byteLength!=U.byteLength||!Le(new an(V),new an(U)));case or:case ur:case ar:return at(+V,+U);case Er:return V.name==U.name&&V.message==U.message;case cr:case sr:return V==U+"";case it:var jt=O;case ot:var Ar=1&gt;if(jt||(jt=q),V.size!=U.size&&!Ar)return!1;var qt=xt.get(V);if(qt)return qt==U;gt|=2,xt.set(V,U);var ht=Qo(jt(V),jt(U),gt,ir,Le,xt);return xt.delete(V),ht;case Lr:if(Cr)return Cr.call(V)==Cr.call(U)}return!1}(s,l,D,g,p,y,b);if(!(1&g)){var j=x&&ae.call(s,"__wrapped__"),W=A&&ae.call(l,"__wrapped__");if(j||W){var te=j?s.value():s,ve=W?l.value():l;return b||(b=new ut),y(te,ve,g,p,b)}}return!!B&&(b||(b=new ut),function(V,U,Vt,gt,ir,Le){var xt=1&Vt,jt=ii(V),Ar=jt.length;if(Ar!=ii(U).length&&!xt)return!1;for(var qt=Ar;qt--;){var ht=jt[qt];if(!(xt?ht in U:ae.call(U,ht)))return!1}var ea=Le.get(V),ta=Le.get(U);if(ea&&ta)return ea==U&&ta==V;var _n=!0;Le.set(V,U),Le.set(U,V);for(var Ri=xt;++qt<Ar;){ht=jt[qt];var mn=V[ht],yn=U[ht];if(gt)var ra=xt?gt(yn,mn,ht,U,V,Le):gt(mn,yn,ht,V,U,Le);if(!(ra===f?mn===yn||ir(mn,yn,Vt,gt,Le):ra)){_n=!1;break}Ri||(Ri=ht=="constructor")}if(_n&&!Ri){var bn=V.constructor,wn=U.constructor;bn!=wn&&"constructor"in V&&"constructor"in U&&!(typeof bn=="function"&&bn instanceof bn&&typeof wn=="function"&&wn instanceof wn)&&(_n=!1)}return Le.delete(V),Le.delete(U),_n}(s,l,g,p,y,b))}(e,t,r,n,pr,u))}function Bn(e,t,r,n){var u=r.length,s=u,l=!n;if(e==null)return!s;for(e=de(e);u--;){var g=r[u];if(l&&g[2]?g[1]!==e[g[0]]:!(g[0]in e))return!1}for(;++u<s;){var p=(g=r[u])[0],y=e[p],b=g[1];if(l&&g[2]){if(y===f&&!(p in e))return!1}else{var C=new ut;if(n)var L=n(y,b,p,e,t,C);if(!(L===f?pr(b,y,3,n,C):L))return!1}}return!0}function wo(e){return!(!pe(e)||function(t){return!!Lu&&Lu in t}(e))&&(wt(e)?yc:Ia).test(Wt(e))}function ko(e){return typeof e=="function"?e:e==null?Ke:typeof e=="object"?H(e)?Io(e[0],e[1]):Co(e):Eu(e)}function $n(e){if(!mr(e))return Ic(e);var t=[];for(var r in de(e))ae.call(e,r)&&r!="constructor"&&t.push(r);return t}function nc(e){if(!pe(e))return function(u){var s=[];if(u!=null)for(var l in de(u))s.push(l);return s}(e);var t=mr(e),r=[];for(var n in e)(n!="constructor"||!t&&ae.call(e,n))&&r.push(n);return r}function Un(e,t){return e<t}function xo(e,t){var r=-1,n=ze(e)?ke(e.length):[];return Lt(e,function(u,s,l){n[++r]=t(u,s,l)}),n}function Co(e){var t=ui(e);return t.length==1&&t[0][2]?tu(t[0][0],t[0][1]):function(r){return r===e||Bn(r,e,t)}}function Io(e,t){return ai(e)&&eu(t)?tu(dt(e),t):function(r){var n=gi(r,e);return n===f&&n===t?hi(r,e):pr(t,n,3)}}function Pr(e,t,r,n,u){e!==t&&Ai(t,function(s,l){if(u||(u=new ut),pe(s))(function(p,y,b,C,L,D,R){var x=si(p,b),A=si(y,b),B=R.get(A);if(B)return Wn(p,b,B),f;var j=D?D(x,A,b+"",p,y,R):f,W=j===f;if(W){var te=H(A),ve=!te&&Tt(A),V=!te&&!ve&&nr(A);j=A,te||ve||V?H(x)?j=x:be(x)?j=Pe(x):ve?(W=!1,j=Mo(A,!0)):V?(W=!1,j=Fo(A,!0)):j=[]:yr(A)||Nt(A)?(j=x,Nt(x)?j=xu(x):pe(x)&&!wt(x)||(j=Jo(A))):W=!1}W&&(R.set(A,j),L(j,A,C,D,R),R.delete(A)),Wn(p,b,j)})(e,t,l,r,Pr,n,u);else{var g=n?n(si(e,l),s,l+"",e,t,u):f;g===f&&(g=s),Wn(e,l,g)}},We)}function Ao(e,t){var r=e.length;if(r)return bt(t+=t<0?r:0,r)?e[t]:f}function So(e,t,r){t=t.length?$(t,function(u){return H(u)?function(s){return Pt(s,u.length===1?u[0]:u)}:u}):[Ke];var n=-1;return t=$(t,m(N())),function(u,s){var l=u.length;for(u.sort(s);l--;)u[l]=u[l].value;return u}(xo(e,function(u,s,l){return{criteria:$(t,function(g){return g(u)}),index:++n,value:u}}),function(u,s){return function(l,g,p){for(var y=-1,b=l.criteria,C=g.criteria,L=b.length,D=p.length;++y<L;){var R=Po(b[y],C[y]);if(R)return y>=D?R:R*(p[y]=="desc"?-1:1)}return l.index-g.index}(u,s,r)})}function Eo(e,t,r){for(var n=-1,u=t.length,s={};++n<u;){var l=t[n],g=Pt(e,l);r(g,l)&&vr(s,St(l,e),g)}return s}function Hn(e,t,r,n){var u=n?Ve:Ee,s=-1,l=t.length,g=e;for(e===t&&(t=Pe(t)),r&&(g=$(e,m(r)));++s<l;)for(var p=0,y=t[s],b=r?r(y):y;(p=u(g,b,p,n))>-1;)g!==e&&sn.call(g,p,1),sn.call(e,p,1);return e}function Do(e,t){for(var r=e?t.length:0,n=r-1;r--;){var u=t[r];if(r==n||u!==s){var s=u;bt(u)?sn.call(e,u,1):Qn(e,u)}}return e}function Zn(e,t){return e+dn(Fu()*(t-e+1))}function Gn(e,t){var r="";if(!e||t<1||t>st)return r;do t%2&&(r+=e),(t=dn(t/2))&&(e+=e);while(t);return r}function X(e,t){return Di(ru(e,t,Ke),e+"")}function ic(e){return ho(Qt(e))}function oc(e,t){var r=Qt(e);return Hr(r,Ft(t,0,r.length))}function vr(e,t,r,n){if(!pe(e))return e;for(var u=-1,s=(t=St(t,e)).length,l=s-1,g=e;g!=null&&++u<s;){var p=dt(t[u]),y=r;if(p==="__proto__"||p==="constructor"||p==="prototype")return e;if(u!=l){var b=g[p];(y=n?n(b,p,g):f)===f&&(y=pe(b)?b:bt(t[u+1])?[]:{})}dr(g,p,y),g=g[p]}return e}function uc(e){return Hr(Qt(e))}function Xe(e,t,r){var n=-1,u=e.length;t<0&&(t=-t>u?0:u+t),(r=r>u?u:r)<0&&(r+=u),u=t>r?0:r-t>>>0,t>>>=0;for(var s=ke(u);++n<u;)s[n]=e[n+t];return s}function ac(e,t){var r;return Lt(e,function(n,u,s){return!(r=t(n,u,s))}),!!r}function zr(e,t,r){var n=0,u=e==null?n:e.length;if(typeof t=="number"&&t==t&&u<=2147483647){for(;n<u;){var s=n+u>>>1,l=e[s];l!==null&&!Ue(l)&&(r?l<=t:l<t)?n=s+1:u=s}return u}return Xn(e,t,Ke,r)}function Xn(e,t,r,n){var u=0,s=e==null?0:e.length;if(s===0)return 0;for(var l=(t=r(t))!=t,g=t===null,p=Ue(t),y=t===f;u<s;){var b=dn((u+s)/2),C=r(e[b]),L=C!==f,D=C===null,R=C==C,x=Ue(C);if(l)var A=n||R;else A=y?R&&(n||L):g?R&&L&&(n||!D):p?R&&L&&!D&&(n||!x):!D&&!x&&(n?C<=t:C<t);A?u=b+1:s=b}return je(s,4294967294)}function Lo(e,t){for(var r=-1,n=e.length,u=0,s=[];++r<n;){var l=e[r],g=t?t(l):l;if(!r||!at(g,p)){var p=g;s[u++]=l===0?0:l}}return s}function To(e){return typeof e=="number"?e:Ue(e)?Bt:+e}function $e(e){if(typeof e=="string")return e;if(H(e))return $(e,$e)+"";if(Ue(e))return Pu?Pu.call(e):"";var t=e+"";return t=="0"&&1/e==-1/0?"-0":t}function At(e,t,r){var n=-1,u=he,s=e.length,l=!0,g=[],p=g;if(r)l=!1,u=we;else if(s>=200){var y=t?null:Fc(e);if(y)return q(y);l=!1,u=c,p=new Mt}else p=t?[]:g;e:for(;++n<s;){var b=e[n],C=t?t(b):b;if(b=r||b!==0?b:0,l&&C==C){for(var L=p.length;L--;)if(p[L]===C)continue e;t&&p.push(C),g.push(b)}else u(p,C,r)||(p!==g&&p.push(C),g.push(b))}return g}function Qn(e,t){return(e=nu(e,t=St(t,e)))==null||delete e[dt(Qe(t))]}function jo(e,t,r,n){return vr(e,t,r(Pt(e,t)),n)}function Wr(e,t,r,n){for(var u=e.length,s=n?u:-1;(n?s--:++s<u)&&t(e[s],s,e););return r?Xe(e,n?0:s,n?s+1:u):Xe(e,n?s+1:0,n?u:s)}function Oo(e,t){var r=e;return r instanceof T&&(r=r.value()),me(t,function(n,u){return u.func.apply(u.thisArg,re([n],u.args))},r)}function Yn(e,t,r){var n=e.length;if(n<2)return n?At(e[0]):[];for(var u=-1,s=ke(n);++u<n;)for(var l=e[u],g=-1;++g<n;)g!=u&&(s[u]=gr(s[u]||l,e[g],t,r));return At(De(s,1),t,r)}function Ro(e,t,r){for(var n=-1,u=e.length,s=t.length,l={};++n<u;)r(l,e[n],n<s?t[n]:f);return l}function Jn(e){return be(e)?e:[]}function ei(e){return typeof e=="function"?e:Ke}function St(e,t){return H(e)?e:ai(e,t)?[e]:Bu(oe(e))}function Et(e,t,r){var n=e.length;return r=r===f?n:r,!t&&r>=n?e:Xe(e,t,r)}function Mo(e,t){if(t)return e.slice();var r=e.length,n=Tu?Tu(r):new e.constructor(r);return e.copy(n),n}function ti(e){var t=new e.constructor(e.byteLength);return new an(t).set(new an(e)),t}function Fo(e,t){return new e.constructor(t?ti(e.buffer):e.buffer,e.byteOffset,e.length)}function Po(e,t){if(e!==t){var r=e!==f,n=e===null,u=e==e,s=Ue(e),l=t!==f,g=t===null,p=t==t,y=Ue(t);if(!g&&!y&&!s&&e>t||s&&l&&p&&!g&&!y||n&&l&&p||!r&&p||!u)return 1;if(!n&&!s&&!y&&e<t||y&&r&&u&&!n&&!s||g&&r&&u||!l&&u||!p)return-1}return 0}function zo(e,t,r,n){for(var u=-1,s=e.length,l=r.length,g=-1,p=t.length,y=xe(s-l,0),b=ke(p+y),C=!n;++g<p;)b[g]=t[g];for(;++u<l;)(C||u<s)&&(b[r[u]]=e[u]);for(;y--;)b[g++]=e[u++];return b}function Wo(e,t,r,n){for(var u=-1,s=e.length,l=-1,g=r.length,p=-1,y=t.length,b=xe(s-g,0),C=ke(b+y),L=!n;++u<b;)C[u]=e[u];for(var D=u;++p<y;)C[D+p]=t[p];for(;++l<g;)(L||u<s)&&(C[D+r[l]]=e[u++]);return C}function Pe(e,t){var r=-1,n=e.length;for(t||(t=ke(n));++r<n;)t[r]=e[r];return t}function lt(e,t,r,n){var u=!r;r||(r={});for(var s=-1,l=t.length;++s<l;){var g=t[s],p=n?n(r[g],e[g],g,r,e):f;p===f&&(p=e[g]),u?_t(r,g,p):dr(r,g,p)}return r}function Kr(e,t){return function(r,n){var u=H(r)?d:Ja,s=t?t():{};return u(r,e,N(n,2),s)}}function Zt(e){return X(function(t,r){var n=-1,u=r.length,s=u>1?r[u-1]:f,l=u>2?r[2]:f;for(s=e.length>3&&typeof s=="function"?(u--,s):f,l&&Me(r[0],r[1],l)&&(s=u<3?f:s,u=1),t=de(t);++n<u;){var g=r[n];g&&e(t,g,n,s)}return t})}function Ko(e,t){return function(r,n){if(r==null)return r;if(!ze(r))return e(r,n);for(var u=r.length,s=t?u:-1,l=de(r);(t?s--:++s<u)&&n(l[s],s,l)!==!1;);return r}}function No(e){return function(t,r,n){for(var u=-1,s=de(t),l=n(t),g=l.length;g--;){var p=l[e?g:++u];if(r(s[p],p,s)===!1)break}return t}}function Vo(e){return function(t){var r=w(t=oe(t))?S(t):f,n=r?r[0]:t.charAt(0),u=r?Et(r,1).join(""):t.slice(1);return n[e]()+u}}function Gt(e){return function(t){return me(Su(Au(t).replace(Fa,"")),e,"")}}function _r(e){return function(){var t=arguments;switch(t.length){case 0:return new e;case 1:return new e(t[0]);case 2:return new e(t[0],t[1]);case 3:return new e(t[0],t[1],t[2]);case 4:return new e(t[0],t[1],t[2],t[3]);case 5:return new e(t[0],t[1],t[2],t[3],t[4]);case 6:return new e(t[0],t[1],t[2],t[3],t[4],t[5]);case 7:return new e(t[0],t[1],t[2],t[3],t[4],t[5],t[6])}var r=rr(e.prototype),n=e.apply(r,t);return pe(n)?n:r}}function cc(e,t,r){var n=_r(e);return function u(){for(var s=arguments.length,l=ke(s),g=s,p=Xt(u);g--;)l[g]=arguments[g];var y=s<3&&l[0]!==p&&l[s-1]!==p?[]:P(l,p);return(s-=y.length)<r?Ho(e,t,Nr,u.placeholder,f,l,y,f,f,r-s):Y(this&&this!==Ae&&this instanceof u?n:e,this,l)}}function qo(e){return function(t,r,n){var u=de(t);if(!ze(t)){var s=N(r,3);t=Se(t),r=function(g){return s(u[g],g,u)}}var l=e(t,r,n);return l>-1?u[s?t[l]:l]:f}}function Bo(e){return yt(function(t){var r=t.length,n=r,u=z.prototype.thru;for(e&&t.reverse();n--;){var s=t[n];if(typeof s!="function")throw new Je(G);if(u&&!l&&$r(s)=="wrapper")var l=new z([],!0)}for(n=l?n:r;++n<r;){var g=$r(s=t[n]),p=g=="wrapper"?Si(s):f;l=p&&ci(p[0])&&p[1]==424&&!p[4].length&&p[9]==1?l[$r(p[0])].apply(l,p[3]):s.length==1&&ci(s)?l[g]():l.thru(s)}return function(){var y=arguments,b=y[0];if(l&&y.length==1&&H(b))return l.plant(b).value();for(var C=0,L=r?t[C].apply(this,y):b;++C<r;)L=t[C].call(this,L);return L}})}function Nr(e,t,r,n,u,s,l,g,p,y){var b=t&qe,C=1&t,L=2&t,D=24&t,R=512&t,x=L?f:_r(e);return function A(){for(var B=arguments.length,j=ke(B),W=B;W--;)j[W]=arguments[W];if(D)var te=Xt(A),ve=h(j,te);if(n&&(j=zo(j,n,u,D)),s&&(j=Wo(j,s,l,D)),B-=ve,D&&B<y)return Ho(e,t,Nr,A.placeholder,r,j,P(j,te),g,p,y-B);var V=C?r:this,U=L?V[e]:e;return B=j.length,g?j=dc(j,g):R&&B>1&&j.reverse(),b&&p<B&&(j.length=p),this&&this!==Ae&&this instanceof A&&(U=x||_r(U)),U.apply(V,j)}}function $o(e,t){return function(r,n){return function(u,s,l,g){return ft(u,function(p,y,b){s(g,l(p),y,b)}),g}(r,e,t(n),{})}}function Vr(e,t){return function(r,n){var u;if(r===f&&n===f)return t;if(r!==f&&(u=r),n!==f){if(u===f)return n;typeof r=="string"||typeof n=="string"?(r=$e(r),n=$e(n)):(r=To(r),n=To(n)),u=e(r,n)}return u}}function ri(e){return yt(function(t){return t=$(t,m(N())),X(function(r){var n=this;return e(t,function(u){return Y(u,n,r)})})})}function qr(e,t){var r=(t=t===f?" ":$e(t)).length;if(r<2)return r?Gn(t,e):t;var n=Gn(t,ln(e/E(t)));return w(t)?Et(S(n),0,e).join(""):n.slice(0,e)}function sc(e,t,r,n){var u=1&t,s=_r(e);return function l(){for(var g=-1,p=arguments.length,y=-1,b=n.length,C=ke(b+p),L=this&&this!==Ae&&this instanceof l?s:e;++y<b;)C[y]=n[y];for(;p--;)C[y++]=arguments[++g];return Y(L,u?r:this,C)}}function Uo(e){return function(t,r,n){return n&&typeof n!="number"&&Me(t,r,n)&&(r=n=f),t=kt(t),r===f?(r=t,t=0):r=kt(r),function(u,s,l,g){for(var p=-1,y=xe(ln((s-u)/(l||1)),0),b=ke(y);y--;)b[g?y:++p]=u,u+=l;return b}(t,r,n=n===f?t<r?1:-1:kt(n),e)}}function Br(e){return function(t,r){return typeof t=="string"&&typeof r=="string"||(t=Ye(t),r=Ye(r)),e(t,r)}}function Ho(e,t,r,n,u,s,l,g,p,y){var b=8&t;t|=b?32:64,4&(t&=~(b?64:32))||(t&=-4);var C=[e,t,u,b?s:f,b?l:f,b?f:s,b?f:l,g,p,y],L=r.apply(f,C);return ci(e)&&qu(L,C),L.placeholder=n,iu(L,e,t)}function ni(e){var t=Yt[e];return function(r,n){if(r=Ye(r),(n=n==null?0:je(Z(n),292))&&Mu(r)){var u=(oe(r)+"e").split("e");return+((u=(oe(t(u[0]+"e"+(+u[1]+n)))+"e").split("e"))[0]+"e"+(+u[1]-n))}return t(r)}}function Zo(e){return function(t){var r=Oe(t);return r==it?O(t):r==ot?function(n){var u=-1,s=Array(n.size);return n.forEach(function(l){s[++u]=[l,l]}),s}(t):function(n,u){return $(u,function(s){return[s,n[s]]})}(t,e(t))}}function mt(e,t,r,n,u,s,l,g){var p=2&t;if(!p&&typeof e!="function")throw new Je(G);var y=n?n.length:0;if(y||(t&=-97,n=u=f),l=l===f?l:xe(Z(l),0),g=g===f?g:Z(g),y-=u?u.length:0,64&t){var b=n,C=u;n=u=f}var L=p?f:Si(e),D=[e,t,r,n,u,b,C,s,l,g];if(L&&function(x,A){var B=x[1],j=A[1],W=B|j,te=W<131,ve=j==qe&&B==8||j==qe&&B==256&&x[7].length<=A[8]||j==384&&A[7].length<=A[8]&&B==8;if(!te&&!ve)return x;1&j&&(x[2]=A[2],W|=1&B?0:4);var V=A[3];if(V){var U=x[3];x[3]=U?zo(U,V,A[4]):V,x[4]=U?P(x[3],Ie):A[4]}(V=A[5])&&(U=x[5],x[5]=U?Wo(U,V,A[6]):V,x[6]=U?P(x[5],Ie):A[6]),(V=A[7])&&(x[7]=V),j&qe&&(x[8]=x[8]==null?A[8]:je(x[8],A[8])),x[9]==null&&(x[9]=A[9]),x[0]=A[0],x[1]=W}(D,L),e=D[0],t=D[1],r=D[2],n=D[3],u=D[4],!(g=D[9]=D[9]===f?p?0:e.length:xe(D[9]-y,0))&&24&t&&(t&=-25),t&&t!=1)R=t==8||t==16?cc(e,t,g):t!=32&&t!=33||u.length?Nr.apply(f,D):sc(e,t,r,n);else var R=function(x,A,B){var j=1&A,W=_r(x);return function te(){return(this&&this!==Ae&&this instanceof te?W:x).apply(j?B:this,arguments)}}(e,t,r);return iu((L?Ku:qu)(R,D),e,t)}function Go(e,t,r,n){return e===f||at(e,Jt[r])&&!ae.call(n,r)?t:e}function Xo(e,t,r,n,u,s){return pe(e)&&pe(t)&&(s.set(t,e),Pr(e,t,f,Xo,s),s.delete(t)),e}function fc(e){return yr(e)?f:e}function Qo(e,t,r,n,u,s){var l=1&r,g=e.length,p=t.length;if(g!=p&&!(l&&p>g))return!1;var y=s.get(e),b=s.get(t);if(y&&b)return y==t&&b==e;var C=-1,L=!0,D=2&r?new Mt:f;for(s.set(e,t),s.set(t,e);++C<g;){var R=e[C],x=t[C];if(n)var A=l?n(x,R,C,t,e,s):n(R,x,C,e,t,s);if(A!==f){if(A)continue;L=!1;break}if(D){if(!ne(t,function(B,j){if(!c(D,j)&&(R===B||u(R,B,r,n,s)))return D.push(j)})){L=!1;break}}else if(R!==x&&!u(R,x,r,n,s)){L=!1;break}}return s.delete(e),s.delete(t),L}function yt(e){return Di(ru(e,f,su),e+"")}function ii(e){return yo(e,Se,Ei)}function oi(e){return yo(e,We,Vu)}function $r(e){for(var t=e.name+"",r=tr[t],n=ae.call(tr,t)?r.length:0;n--;){var u=r[n],s=u.func;if(s==null||s==e)return u.name}return t}function Xt(e){return(ae.call(o,"placeholder")?o:e).placeholder}function N(){var e=o.iteratee||vi;return e=e===vi?ko:e,arguments.length?e(arguments[0],arguments[1]):e}function Ur(e,t){var r=e.__data__;return function(n){var u=typeof n;return u=="string"||u=="number"||u=="symbol"||u=="boolean"?n!=="__proto__":n===null}(t)?r[typeof t=="string"?"string":"hash"]:r.map}function ui(e){for(var t=Se(e),r=t.length;r--;){var n=t[r],u=e[n];t[r]=[n,u,eu(u)]}return t}function zt(e,t){var r=function(n,u){return n==null?f:n[u]}(e,t);return wo(r)?r:f}function Yo(e,t,r){for(var n=-1,u=(t=St(t,e)).length,s=!1;++n<u;){var l=dt(t[n]);if(!(s=e!=null&&r(e,l)))break;e=e[l]}return s||++n!=u?s:!!(u=e==null?0:e.length)&&Yr(u)&&bt(l,u)&&(H(e)||Nt(e))}function Jo(e){return typeof e.constructor!="function"||mr(e)?{}:rr(cn(e))}function lc(e){return H(e)||Nt(e)||!!(Ru&&e&&e[Ru])}function bt(e,t){var r=typeof e;return!!(t=t??st)&&(r=="number"||r!="symbol"&&Sa.test(e))&&e>-1&&e%1==0&&e<t}function Me(e,t,r){if(!pe(r))return!1;var n=typeof t;return!!(n=="number"?ze(r)&&bt(t,r.length):n=="string"&&t in r)&&at(r[t],e)}function ai(e,t){if(H(e))return!1;var r=typeof e;return!(r!="number"&&r!="symbol"&&r!="boolean"&&e!=null&&!Ue(e))||da.test(e)||!la.test(e)||t!=null&&e in de(t)}function ci(e){var t=$r(e),r=o[t];if(typeof r!="function"||!(t in T.prototype))return!1;if(e===r)return!0;var n=Si(r);return!!n&&e===n[0]}function mr(e){var t=e&&e.constructor;return e===(typeof t=="function"&&t.prototype||Jt)}function eu(e){return e==e&&!pe(e)}function tu(e,t){return function(r){return r!=null&&r[e]===t&&(t!==f||e in de(r))}}function ru(e,t,r){return t=xe(t===f?e.length-1:t,0),function(){for(var n=arguments,u=-1,s=xe(n.length-t,0),l=ke(s);++u<s;)l[u]=n[t+u];u=-1;for(var g=ke(t+1);++u<t;)g[u]=n[u];return g[t]=r(l),Y(e,this,g)}}function nu(e,t){return t.length<2?e:Pt(e,Xe(t,0,-1))}function dc(e,t){for(var r=e.length,n=je(t.length,r),u=Pe(e);n--;){var s=t[n];e[n]=bt(s,r)?u[s]:f}return e}function si(e,t){if((t!=="constructor"||typeof e[t]!="function")&&t!="__proto__")return e[t]}function iu(e,t,r){var n=t+"";return Di(e,function(u,s){var l=s.length;if(!l)return u;var g=l-1;return s[g]=(l>1?"& ":"")+s[g],s=s.join(l>2?", ":" "),u.replace(va,`{
/* [wrapped with `+s+`] */
`)}(n,gc(function(u){var s=u.match(_a);return s?s[1].split(ma):[]}(n),r)))}function ou(e){var t=0,r=0;return function(){var n=Ac(),u=16-(n-r);if(r=n,u>0){if(++t>=800)return arguments[0]}else t=0;return e.apply(f,arguments)}}function Hr(e,t){var r=-1,n=e.length,u=n-1;for(t=t===f?n:t;++r<t;){var s=Zn(r,u),l=e[s];e[s]=e[r],e[r]=l}return e.length=t,e}function dt(e){if(typeof e=="string"||Ue(e))return e;var t=e+"";return t=="0"&&1/e==-1/0?"-0":t}function Wt(e){if(e!=null){try{return nn.call(e)}catch{}try{return e+""}catch{}}return""}function gc(e,t){return K(na,function(r){var n="_."+r[0];t&r[1]&&!he(e,n)&&e.push(n)}),e.sort()}function uu(e){if(e instanceof T)return e.clone();var t=new z(e.__wrapped__,e.__chain__);return t.__actions__=Pe(e.__actions__),t.__index__=e.__index__,t.__values__=e.__values__,t}function au(e,t,r){var n=e==null?0:e.length;if(!n)return-1;var u=r==null?0:Z(r);return u<0&&(u=xe(n+u,0)),Te(e,N(t,3),u)}function cu(e,t,r){var n=e==null?0:e.length;if(!n)return-1;var u=n-1;return r!==f&&(u=Z(r),u=r<0?xe(n+u,0):je(u,n-1)),Te(e,N(t,3),u,!0)}function su(e){return e!=null&&e.length?De(e,1):[]}function fu(e){return e&&e.length?e[0]:f}function Qe(e){var t=e==null?0:e.length;return t?e[t-1]:f}function lu(e,t){return e&&e.length&&t&&t.length?Hn(e,t):e}function fi(e){return e==null?e:Ec.call(e)}function li(e){if(!e||!e.length)return[];var t=0;return e=ie(e,function(r){if(be(r))return t=xe(r.length,t),!0}),rt(t,function(r){return $(e,Ce(r))})}function du(e,t){if(!e||!e.length)return[];var r=li(e);return t==null?r:$(r,function(n){return Y(t,f,n)})}function gu(e){var t=o(e);return t.__chain__=!0,t}function Zr(e,t){return t(e)}function hu(e,t){return(H(e)?K:Lt)(e,N(t,3))}function pu(e,t){return(H(e)?Q:zu)(e,N(t,3))}function Gr(e,t){return(H(e)?$:xo)(e,N(t,3))}function vu(e,t,r){return t=r?f:t,t=e&&t==null?e.length:t,mt(e,qe,f,f,f,f,t)}function _u(e,t){var r;if(typeof t!="function")throw new Je(G);return e=Z(e),function(){return--e>0&&(r=t.apply(this,arguments)),e<=1&&(t=f),r}}function mu(e,t,r){function n(W){var te=y,ve=b;return y=b=f,x=W,L=e.apply(ve,te)}function u(W){return x=W,D=Ir(l,t),A?n(W):L}function s(W){var te=W-R;return R===f||te>=t||te<0||B&&W-x>=C}function l(){var W=pn();return s(W)?g(W):(D=Ir(l,function(te){var ve=t-(te-R);return B?je(ve,C-(te-x)):ve}(W)),f)}function g(W){return D=f,j&&y?n(W):(y=b=f,L)}function p(){var W=pn(),te=s(W);if(y=arguments,b=this,R=W,te){if(D===f)return u(R);if(B)return Nu(D),D=Ir(l,t),n(R)}return D===f&&(D=Ir(l,t)),L}var y,b,C,L,D,R,x=0,A=!1,B=!1,j=!0;if(typeof e!="function")throw new Je(G);return t=Ye(t)||0,pe(r)&&(A=!!r.leading,C=(B="maxWait"in r)?xe(Ye(r.maxWait)||0,t):C,j="trailing"in r?!!r.trailing:j),p.cancel=function(){D!==f&&Nu(D),x=0,y=R=b=D=f},p.flush=function(){return D===f?L:g(pn())},p}function Xr(e,t){if(typeof e!="function"||t!=null&&typeof t!="function")throw new Je(G);var r=function(){var n=arguments,u=t?t.apply(this,n):n[0],s=r.cache;if(s.has(u))return s.get(u);var l=e.apply(this,n);return r.cache=s.set(u,l)||s,l};return r.cache=new(Xr.Cache||vt),r}function Qr(e){if(typeof e!="function")throw new Je(G);return function(){var t=arguments;switch(t.length){case 0:return!e.call(this);case 1:return!e.call(this,t[0]);case 2:return!e.call(this,t[0],t[1]);case 3:return!e.call(this,t[0],t[1],t[2])}return!e.apply(this,t)}}function at(e,t){return e===t||e!=e&&t!=t}function ze(e){return e!=null&&Yr(e.length)&&!wt(e)}function be(e){return _e(e)&&ze(e)}function di(e){if(!_e(e))return!1;var t=Re(e);return t==Er||t=="[object DOMException]"||typeof e.message=="string"&&typeof e.name=="string"&&!yr(e)}function wt(e){if(!pe(e))return!1;var t=Re(e);return t==Dr||t==Mi||t=="[object AsyncFunction]"||t=="[object Proxy]"}function yu(e){return typeof e=="number"&&e==Z(e)}function Yr(e){return typeof e=="number"&&e>-1&&e%1==0&&e<=st}function pe(e){var t=typeof e;return e!=null&&(t=="object"||t=="function")}function _e(e){return e!=null&&typeof e=="object"}function bu(e){return typeof e=="number"||_e(e)&&Re(e)==ar}function yr(e){if(!_e(e)||Re(e)!=pt)return!1;var t=cn(e);if(t===null)return!0;var r=ae.call(t,"constructor")&&t.constructor;return typeof r=="function"&&r instanceof r&&nn.call(r)==_c}function Jr(e){return typeof e=="string"||!H(e)&&_e(e)&&Re(e)==sr}function Ue(e){return typeof e=="symbol"||_e(e)&&Re(e)==Lr}function wu(e){if(!e)return[];if(ze(e))return Jr(e)?S(e):Pe(e);if(br&&e[br])return function(r){for(var n,u=[];!(n=r.next()).done;)u.push(n.value);return u}(e[br]());var t=Oe(e);return(t==it?O:t==ot?q:Qt)(e)}function kt(e){return e?(e=Ye(e))===1/0||e===-1/0?17976931348623157e292*(e<0?-1:1):e==e?e:0:e===0?e:0}function Z(e){var t=kt(e),r=t%1;return t==t?r?t-r:t:0}function ku(e){return e?Ft(Z(e),0,Ct):0}function Ye(e){if(typeof e=="number")return e;if(Ue(e))return Bt;if(pe(e)){var t=typeof e.valueOf=="function"?e.valueOf():e;e=pe(t)?t+"":t}if(typeof e!="string")return e===0?e:+e;e=nt(e);var r=Ca.test(e);return r||Aa.test(e)?$a(e.slice(2),r?2:8):xa.test(e)?Bt:+e}function xu(e){return lt(e,We(e))}function oe(e){return e==null?"":$e(e)}function gi(e,t,r){var n=e==null?f:Pt(e,t);return n===f?r:n}function hi(e,t){return e!=null&&Yo(e,t,rc)}function Se(e){return ze(e)?go(e):$n(e)}function We(e){return ze(e)?go(e,!0):nc(e)}function Cu(e,t){if(e==null)return{};var r=$(oi(e),function(n){return[n]});return t=N(t),Eo(e,r,function(n,u){return t(n,u[0])})}function Qt(e){return e==null?[]:Ot(e,Se(e))}function Iu(e){return Oi(oe(e).toLowerCase())}function Au(e){return(e=oe(e))&&e.replace(Ea,Za).replace(Pa,"")}function Su(e,t,r){return e=oe(e),(t=r?f:t)===f?I(e)?ee(e):ye(e):e.match(t)||[]}function pi(e){return function(){return e}}function Ke(e){return e}function vi(e){return ko(typeof e=="function"?e:Ge(e,1))}function _i(e,t,r){var n=Se(t),u=Fr(t,n);r!=null||pe(t)&&(u.length||!n.length)||(r=t,t=e,e=this,u=Fr(t,Se(t)));var s=!(pe(r)&&"chain"in r&&!r.chain),l=wt(e);return K(u,function(g){var p=t[g];e[g]=p,l&&(e.prototype[g]=function(){var y=this.__chain__;if(s||y){var b=e(this.__wrapped__);return(b.__actions__=Pe(this.__actions__)).push({func:p,args:arguments,thisArg:e}),b.__chain__=y,b}return p.apply(e,re([this.value()],arguments))})}),e}function mi(){}function Eu(e){return ai(e)?Ce(dt(e)):function(t){return function(r){return Pt(r,t)}}(e)}function yi(){return[]}function bi(){return!1}var ke=(k=k==null?Ae:It.defaults(Ae.Object(),k,It.pick(Ae,Na))).Array,en=k.Date,wi=k.Error,Du=k.Function,Yt=k.Math,de=k.Object,ki=k.RegExp,hc=k.String,Je=k.TypeError,tn=ke.prototype,pc=Du.prototype,Jt=de.prototype,rn=k["__core-js_shared__"],nn=pc.toString,ae=Jt.hasOwnProperty,vc=0,Lu=function(){var e=/[^.]+$/.exec(rn&&rn.keys&&rn.keys.IE_PROTO||"");return e?"Symbol(src)_1."+e:""}(),on=Jt.toString,_c=nn.call(de),mc=Ae._,yc=ki("^"+nn.call(ae).replace(Tn,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),un=oo?k.Buffer:f,Dt=k.Symbol,an=k.Uint8Array,Tu=un?un.allocUnsafe:f,cn=ue(de.getPrototypeOf,de),ju=de.create,Ou=Jt.propertyIsEnumerable,sn=tn.splice,Ru=Dt?Dt.isConcatSpreadable:f,br=Dt?Dt.iterator:f,Kt=Dt?Dt.toStringTag:f,fn=function(){try{var e=zt(de,"defineProperty");return e({},"",{}),e}catch{}}(),bc=k.clearTimeout!==Ae.clearTimeout&&k.clearTimeout,wc=en&&en.now!==Ae.Date.now&&en.now,kc=k.setTimeout!==Ae.setTimeout&&k.setTimeout,ln=Yt.ceil,dn=Yt.floor,xi=de.getOwnPropertySymbols,xc=un?un.isBuffer:f,Mu=k.isFinite,Cc=tn.join,Ic=ue(de.keys,de),xe=Yt.max,je=Yt.min,Ac=en.now,Sc=k.parseInt,Fu=Yt.random,Ec=tn.reverse,Ci=zt(k,"DataView"),wr=zt(k,"Map"),Ii=zt(k,"Promise"),er=zt(k,"Set"),kr=zt(k,"WeakMap"),xr=zt(de,"create"),gn=kr&&new kr,tr={},Dc=Wt(Ci),Lc=Wt(wr),Tc=Wt(Ii),jc=Wt(er),Oc=Wt(kr),hn=Dt?Dt.prototype:f,Cr=hn?hn.valueOf:f,Pu=hn?hn.toString:f,rr=function(){function e(){}return function(t){if(!pe(t))return{};if(ju)return ju(t);e.prototype=t;var r=new e;return e.prototype=f,r}}();o.templateSettings={escape:sa,evaluate:fa,interpolate:Wi,variable:"",imports:{_:o}},o.prototype=F.prototype,o.prototype.constructor=o,z.prototype=rr(F.prototype),z.prototype.constructor=z,T.prototype=rr(F.prototype),T.prototype.constructor=T,ge.prototype.clear=function(){this.__data__=xr?xr(null):{},this.size=0},ge.prototype.delete=function(e){var t=this.has(e)&&delete this.__data__[e];return this.size-=t?1:0,t},ge.prototype.get=function(e){var t=this.__data__;if(xr){var r=t[e];return r===ce?f:r}return ae.call(t,e)?t[e]:f},ge.prototype.has=function(e){var t=this.__data__;return xr?t[e]!==f:ae.call(t,e)},ge.prototype.set=function(e,t){var r=this.__data__;return this.size+=this.has(e)?0:1,r[e]=xr&&t===f?ce:t,this},Be.prototype.clear=function(){this.__data__=[],this.size=0},Be.prototype.delete=function(e){var t=this.__data__,r=Rr(t,e);return!(r<0||(r==t.length-1?t.pop():sn.call(t,r,1),--this.size,0))},Be.prototype.get=function(e){var t=this.__data__,r=Rr(t,e);return r<0?f:t[r][1]},Be.prototype.has=function(e){return Rr(this.__data__,e)>-1},Be.prototype.set=function(e,t){var r=this.__data__,n=Rr(r,e);return n<0?(++this.size,r.push([e,t])):r[n][1]=t,this},vt.prototype.clear=function(){this.size=0,this.__data__={hash:new ge,map:new(wr||Be),string:new ge}},vt.prototype.delete=function(e){var t=Ur(this,e).delete(e);return this.size-=t?1:0,t},vt.prototype.get=function(e){return Ur(this,e).get(e)},vt.prototype.has=function(e){return Ur(this,e).has(e)},vt.prototype.set=function(e,t){var r=Ur(this,e),n=r.size;return r.set(e,t),this.size+=r.size==n?0:1,this},Mt.prototype.add=Mt.prototype.push=function(e){return this.__data__.set(e,ce),this},Mt.prototype.has=function(e){return this.__data__.has(e)},ut.prototype.clear=function(){this.__data__=new Be,this.size=0},ut.prototype.delete=function(e){var t=this.__data__,r=t.delete(e);return this.size=t.size,r},ut.prototype.get=function(e){return this.__data__.get(e)},ut.prototype.has=function(e){return this.__data__.has(e)},ut.prototype.set=function(e,t){var r=this.__data__;if(r instanceof Be){var n=r.__data__;if(!wr||n.length<199)return n.push([e,t]),this.size=++r.size,this;r=this.__data__=new vt(n)}return r.set(e,t),this.size=r.size,this};var Lt=Ko(ft),zu=Ko(Nn,!0),Ai=No(),Wu=No(!0),Ku=gn?function(e,t){return gn.set(e,t),e}:Ke,Rc=fn?function(e,t){return fn(e,"toString",{configurable:!0,enumerable:!1,value:pi(t),writable:!0})}:Ke,Mc=X,Nu=bc||function(e){return Ae.clearTimeout(e)},Fc=er&&1/q(new er([,-0]))[1]==1/0?function(e){return new er(e)}:mi,Si=gn?function(e){return gn.get(e)}:mi,Ei=xi?function(e){return e==null?[]:(e=de(e),ie(xi(e),function(t){return Ou.call(e,t)}))}:yi,Vu=xi?function(e){for(var t=[];e;)re(t,Ei(e)),e=cn(e);return t}:yi,Oe=Re;(Ci&&Oe(new Ci(new ArrayBuffer(1)))!=Ut||wr&&Oe(new wr)!=it||Ii&&Oe(Ii.resolve())!=Fi||er&&Oe(new er)!=ot||kr&&Oe(new kr)!=fr)&&(Oe=function(e){var t=Re(e),r=t==pt?e.constructor:f,n=r?Wt(r):"";if(n)switch(n){case Dc:return Ut;case Lc:return it;case Tc:return Fi;case jc:return ot;case Oc:return fr}return t});var Pc=rn?wt:bi,qu=ou(Ku),Ir=kc||function(e,t){return Ae.setTimeout(e,t)},Di=ou(Rc),Bu=function(e){var t=Xr(e,function(n){return r.size===500&&r.clear(),n}),r=t.cache;return t}(function(e){var t=[];return e.charCodeAt(0)===46&&t.push(""),e.replace(ga,function(r,n,u,s){t.push(u?s.replace(wa,"$1"):n||r)}),t}),zc=X(function(e,t){return be(e)?gr(e,De(t,1,be,!0)):[]}),Wc=X(function(e,t){var r=Qe(t);return be(r)&&(r=f),be(e)?gr(e,De(t,1,be,!0),N(r,2)):[]}),Kc=X(function(e,t){var r=Qe(t);return be(r)&&(r=f),be(e)?gr(e,De(t,1,be,!0),f,r):[]}),Nc=X(function(e){var t=$(e,Jn);return t.length&&t[0]===e[0]?qn(t):[]}),Vc=X(function(e){var t=Qe(e),r=$(e,Jn);return t===Qe(r)?t=f:r.pop(),r.length&&r[0]===e[0]?qn(r,N(t,2)):[]}),qc=X(function(e){var t=Qe(e),r=$(e,Jn);return(t=typeof t=="function"?t:f)&&r.pop(),r.length&&r[0]===e[0]?qn(r,f,t):[]}),Bc=X(lu),$c=yt(function(e,t){var r=e==null?0:e.length,n=Kn(e,t);return Do(e,$(t,function(u){return bt(u,r)?+u:u}).sort(Po)),n}),Uc=X(function(e){return At(De(e,1,be,!0))}),Hc=X(function(e){var t=Qe(e);return be(t)&&(t=f),At(De(e,1,be,!0),N(t,2))}),Zc=X(function(e){var t=Qe(e);return t=typeof t=="function"?t:f,At(De(e,1,be,!0),f,t)}),Gc=X(function(e,t){return be(e)?gr(e,t):[]}),Xc=X(function(e){return Yn(ie(e,be))}),Qc=X(function(e){var t=Qe(e);return be(t)&&(t=f),Yn(ie(e,be),N(t,2))}),Yc=X(function(e){var t=Qe(e);return t=typeof t=="function"?t:f,Yn(ie(e,be),f,t)}),Jc=X(li),es=X(function(e){var t=e.length,r=t>1?e[t-1]:f;return r=typeof r=="function"?(e.pop(),r):f,du(e,r)}),ts=yt(function(e){var t=e.length,r=t?e[0]:0,n=this.__wrapped__,u=function(s){return Kn(s,e)};return!(t>1||this.__actions__.length)&&n instanceof T&&bt(r)?((n=n.slice(r,+r+(t?1:0))).__actions__.push({func:Zr,args:[u],thisArg:f}),new z(n,this.__chain__).thru(function(s){return t&&!s.length&&s.push(f),s})):this.thru(u)}),rs=Kr(function(e,t,r){ae.call(e,r)?++e[r]:_t(e,r,1)}),ns=qo(au),is=qo(cu),os=Kr(function(e,t,r){ae.call(e,r)?e[r].push(t):_t(e,r,[t])}),us=X(function(e,t,r){var n=-1,u=typeof t=="function",s=ze(e)?ke(e.length):[];return Lt(e,function(l){s[++n]=u?Y(t,l,r):hr(l,t,r)}),s}),as=Kr(function(e,t,r){_t(e,r,t)}),cs=Kr(function(e,t,r){e[r?0:1].push(t)},function(){return[[],[]]}),ss=X(function(e,t){if(e==null)return[];var r=t.length;return r>1&&Me(e,t[0],t[1])?t=[]:r>2&&Me(t[0],t[1],t[2])&&(t=[t[0]]),So(e,De(t,1),[])}),pn=wc||function(){return Ae.Date.now()},Li=X(function(e,t,r){var n=1;if(r.length){var u=P(r,Xt(Li));n|=32}return mt(e,n,t,r,u)}),$u=X(function(e,t,r){var n=3;if(r.length){var u=P(r,Xt($u));n|=32}return mt(t,n,e,r,u)}),fs=X(function(e,t){return _o(e,1,t)}),ls=X(function(e,t,r){return _o(e,Ye(t)||0,r)});Xr.Cache=vt;var ds=Mc(function(e,t){var r=(t=t.length==1&&H(t[0])?$(t[0],m(N())):$(De(t,1),m(N()))).length;return X(function(n){for(var u=-1,s=je(n.length,r);++u<s;)n[u]=t[u].call(this,n[u]);return Y(e,this,n)})}),Ti=X(function(e,t){return mt(e,32,f,t,P(t,Xt(Ti)))}),Uu=X(function(e,t){return mt(e,64,f,t,P(t,Xt(Uu)))}),gs=yt(function(e,t){return mt(e,256,f,f,f,t)}),hs=Br(Vn),ps=Br(function(e,t){return e>=t}),Nt=bo(function(){return arguments}())?bo:function(e){return _e(e)&&ae.call(e,"callee")&&!Ou.call(e,"callee")},H=ke.isArray,vs=uo?m(uo):function(e){return _e(e)&&Re(e)==lr},Tt=xc||bi,_s=ao?m(ao):function(e){return _e(e)&&Re(e)==ur},Hu=co?m(co):function(e){return _e(e)&&Oe(e)==it},ji=so?m(so):function(e){return _e(e)&&Re(e)==cr},Zu=fo?m(fo):function(e){return _e(e)&&Oe(e)==ot},nr=lo?m(lo):function(e){return _e(e)&&Yr(e.length)&&!!le[Re(e)]},ms=Br(Un),ys=Br(function(e,t){return e<=t}),bs=Zt(function(e,t){if(mr(t)||ze(t))return lt(t,Se(t),e),f;for(var r in t)ae.call(t,r)&&dr(e,r,t[r])}),Gu=Zt(function(e,t){lt(t,We(t),e)}),vn=Zt(function(e,t,r,n){lt(t,We(t),e,n)}),ws=Zt(function(e,t,r,n){lt(t,Se(t),e,n)}),ks=yt(Kn),xs=X(function(e,t){e=de(e);var r=-1,n=t.length,u=n>2?t[2]:f;for(u&&Me(t[0],t[1],u)&&(n=1);++r<n;)for(var s=t[r],l=We(s),g=-1,p=l.length;++g<p;){var y=l[g],b=e[y];(b===f||at(b,Jt[y])&&!ae.call(e,y))&&(e[y]=s[y])}return e}),Cs=X(function(e){return e.push(f,Xo),Y(Xu,f,e)}),Is=$o(function(e,t,r){t!=null&&typeof t.toString!="function"&&(t=on.call(t)),e[t]=r},pi(Ke)),As=$o(function(e,t,r){t!=null&&typeof t.toString!="function"&&(t=on.call(t)),ae.call(e,t)?e[t].push(r):e[t]=[r]},N),Ss=X(hr),Es=Zt(function(e,t,r){Pr(e,t,r)}),Xu=Zt(function(e,t,r,n){Pr(e,t,r,n)}),Ds=yt(function(e,t){var r={};if(e==null)return r;var n=!1;t=$(t,function(s){return s=St(s,e),n||(n=s.length>1),s}),lt(e,oi(e),r),n&&(r=Ge(r,7,fc));for(var u=t.length;u--;)Qn(r,t[u]);return r}),Ls=yt(function(e,t){return e==null?{}:function(r,n){return Eo(r,n,function(u,s){return hi(r,s)})}(e,t)}),Qu=Zo(Se),Yu=Zo(We),Ts=Gt(function(e,t,r){return t=t.toLowerCase(),e+(r?Iu(t):t)}),js=Gt(function(e,t,r){return e+(r?"-":"")+t.toLowerCase()}),Os=Gt(function(e,t,r){return e+(r?" ":"")+t.toLowerCase()}),Rs=Vo("toLowerCase"),Ms=Gt(function(e,t,r){return e+(r?"_":"")+t.toLowerCase()}),Fs=Gt(function(e,t,r){return e+(r?" ":"")+Oi(t)}),Ps=Gt(function(e,t,r){return e+(r?" ":"")+t.toUpperCase()}),Oi=Vo("toUpperCase"),Ju=X(function(e,t){try{return Y(e,f,t)}catch(r){return di(r)?r:new wi(r)}}),zs=yt(function(e,t){return K(t,function(r){r=dt(r),_t(e,r,Li(e[r],e))}),e}),Ws=Bo(),Ks=Bo(!0),Ns=X(function(e,t){return function(r){return hr(r,e,t)}}),Vs=X(function(e,t){return function(r){return hr(e,r,t)}}),qs=ri($),Bs=ri(M),$s=ri(ne),Us=Uo(),Hs=Uo(!0),Zs=Vr(function(e,t){return e+t},0),Gs=ni("ceil"),Xs=Vr(function(e,t){return e/t},1),Qs=ni("floor"),Ys=Vr(function(e,t){return e*t},1),Js=ni("round"),ef=Vr(function(e,t){return e-t},0);return o.after=function(e,t){if(typeof t!="function")throw new Je(G);return e=Z(e),function(){if(--e<1)return t.apply(this,arguments)}},o.ary=vu,o.assign=bs,o.assignIn=Gu,o.assignInWith=vn,o.assignWith=ws,o.at=ks,o.before=_u,o.bind=Li,o.bindAll=zs,o.bindKey=$u,o.castArray=function(){if(!arguments.length)return[];var e=arguments[0];return H(e)?e:[e]},o.chain=gu,o.chunk=function(e,t,r){t=(r?Me(e,t,r):t===f)?1:xe(Z(t),0);var n=e==null?0:e.length;if(!n||t<1)return[];for(var u=0,s=0,l=ke(ln(n/t));u<n;)l[s++]=Xe(e,u,u+=t);return l},o.compact=function(e){for(var t=-1,r=e==null?0:e.length,n=0,u=[];++t<r;){var s=e[t];s&&(u[n++]=s)}return u},o.concat=function(){var e=arguments.length;if(!e)return[];for(var t=ke(e-1),r=arguments[0],n=e;n--;)t[n-1]=arguments[n];return re(H(r)?Pe(r):[r],De(t,1))},o.cond=function(e){var t=e==null?0:e.length,r=N();return e=t?$(e,function(n){if(typeof n[1]!="function")throw new Je(G);return[r(n[0]),n[1]]}):[],X(function(n){for(var u=-1;++u<t;){var s=e[u];if(Y(s[0],this,n))return Y(s[1],this,n)}})},o.conforms=function(e){return function(t){var r=Se(t);return function(n){return vo(n,t,r)}}(Ge(e,1))},o.constant=pi,o.countBy=rs,o.create=function(e,t){var r=rr(e);return t==null?r:po(r,t)},o.curry=function e(t,r,n){var u=mt(t,8,f,f,f,f,f,r=n?f:r);return u.placeholder=e.placeholder,u},o.curryRight=function e(t,r,n){var u=mt(t,16,f,f,f,f,f,r=n?f:r);return u.placeholder=e.placeholder,u},o.debounce=mu,o.defaults=xs,o.defaultsDeep=Cs,o.defer=fs,o.delay=ls,o.difference=zc,o.differenceBy=Wc,o.differenceWith=Kc,o.drop=function(e,t,r){var n=e==null?0:e.length;return n?Xe(e,(t=r||t===f?1:Z(t))<0?0:t,n):[]},o.dropRight=function(e,t,r){var n=e==null?0:e.length;return n?Xe(e,0,(t=n-(t=r||t===f?1:Z(t)))<0?0:t):[]},o.dropRightWhile=function(e,t){return e&&e.length?Wr(e,N(t,3),!0,!0):[]},o.dropWhile=function(e,t){return e&&e.length?Wr(e,N(t,3),!0):[]},o.fill=function(e,t,r,n){var u=e==null?0:e.length;return u?(r&&typeof r!="number"&&Me(e,t,r)&&(r=0,n=u),function(s,l,g,p){var y=s.length;for((g=Z(g))<0&&(g=-g>y?0:y+g),(p=p===f||p>y?y:Z(p))<0&&(p+=y),p=g>p?0:ku(p);g<p;)s[g++]=l;return s}(e,t,r,n)):[]},o.filter=function(e,t){return(H(e)?ie:mo)(e,N(t,3))},o.flatMap=function(e,t){return De(Gr(e,t),1)},o.flatMapDeep=function(e,t){return De(Gr(e,t),1/0)},o.flatMapDepth=function(e,t,r){return r=r===f?1:Z(r),De(Gr(e,t),r)},o.flatten=su,o.flattenDeep=function(e){return e!=null&&e.length?De(e,1/0):[]},o.flattenDepth=function(e,t){return e!=null&&e.length?De(e,t=t===f?1:Z(t)):[]},o.flip=function(e){return mt(e,512)},o.flow=Ws,o.flowRight=Ks,o.fromPairs=function(e){for(var t=-1,r=e==null?0:e.length,n={};++t<r;){var u=e[t];n[u[0]]=u[1]}return n},o.functions=function(e){return e==null?[]:Fr(e,Se(e))},o.functionsIn=function(e){return e==null?[]:Fr(e,We(e))},o.groupBy=os,o.initial=function(e){return e!=null&&e.length?Xe(e,0,-1):[]},o.intersection=Nc,o.intersectionBy=Vc,o.intersectionWith=qc,o.invert=Is,o.invertBy=As,o.invokeMap=us,o.iteratee=vi,o.keyBy=as,o.keys=Se,o.keysIn=We,o.map=Gr,o.mapKeys=function(e,t){var r={};return t=N(t,3),ft(e,function(n,u,s){_t(r,t(n,u,s),n)}),r},o.mapValues=function(e,t){var r={};return t=N(t,3),ft(e,function(n,u,s){_t(r,u,t(n,u,s))}),r},o.matches=function(e){return Co(Ge(e,1))},o.matchesProperty=function(e,t){return Io(e,Ge(t,1))},o.memoize=Xr,o.merge=Es,o.mergeWith=Xu,o.method=Ns,o.methodOf=Vs,o.mixin=_i,o.negate=Qr,o.nthArg=function(e){return e=Z(e),X(function(t){return Ao(t,e)})},o.omit=Ds,o.omitBy=function(e,t){return Cu(e,Qr(N(t)))},o.once=function(e){return _u(2,e)},o.orderBy=function(e,t,r,n){return e==null?[]:(H(t)||(t=t==null?[]:[t]),H(r=n?f:r)||(r=r==null?[]:[r]),So(e,t,r))},o.over=qs,o.overArgs=ds,o.overEvery=Bs,o.overSome=$s,o.partial=Ti,o.partialRight=Uu,o.partition=cs,o.pick=Ls,o.pickBy=Cu,o.property=Eu,o.propertyOf=function(e){return function(t){return e==null?f:Pt(e,t)}},o.pull=Bc,o.pullAll=lu,o.pullAllBy=function(e,t,r){return e&&e.length&&t&&t.length?Hn(e,t,N(r,2)):e},o.pullAllWith=function(e,t,r){return e&&e.length&&t&&t.length?Hn(e,t,f,r):e},o.pullAt=$c,o.range=Us,o.rangeRight=Hs,o.rearg=gs,o.reject=function(e,t){return(H(e)?ie:mo)(e,Qr(N(t,3)))},o.remove=function(e,t){var r=[];if(!e||!e.length)return r;var n=-1,u=[],s=e.length;for(t=N(t,3);++n<s;){var l=e[n];t(l,n,e)&&(r.push(l),u.push(n))}return Do(e,u),r},o.rest=function(e,t){if(typeof e!="function")throw new Je(G);return X(e,t=t===f?t:Z(t))},o.reverse=fi,o.sampleSize=function(e,t,r){return t=(r?Me(e,t,r):t===f)?1:Z(t),(H(e)?Qa:oc)(e,t)},o.set=function(e,t,r){return e==null?e:vr(e,t,r)},o.setWith=function(e,t,r,n){return n=typeof n=="function"?n:f,e==null?e:vr(e,t,r,n)},o.shuffle=function(e){return(H(e)?Ya:uc)(e)},o.slice=function(e,t,r){var n=e==null?0:e.length;return n?(r&&typeof r!="number"&&Me(e,t,r)?(t=0,r=n):(t=t==null?0:Z(t),r=r===f?n:Z(r)),Xe(e,t,r)):[]},o.sortBy=ss,o.sortedUniq=function(e){return e&&e.length?Lo(e):[]},o.sortedUniqBy=function(e,t){return e&&e.length?Lo(e,N(t,2)):[]},o.split=function(e,t,r){return r&&typeof r!="number"&&Me(e,t,r)&&(t=r=f),(r=r===f?Ct:r>>>0)?(e=oe(e))&&(typeof t=="string"||t!=null&&!ji(t))&&!(t=$e(t))&&w(e)?Et(S(e),0,r):e.split(t,r):[]},o.spread=function(e,t){if(typeof e!="function")throw new Je(G);return t=t==null?0:xe(Z(t),0),X(function(r){var n=r[t],u=Et(r,0,t);return n&&re(u,n),Y(e,this,u)})},o.tail=function(e){var t=e==null?0:e.length;return t?Xe(e,1,t):[]},o.take=function(e,t,r){return e&&e.length?Xe(e,0,(t=r||t===f?1:Z(t))<0?0:t):[]},o.takeRight=function(e,t,r){var n=e==null?0:e.length;return n?Xe(e,(t=n-(t=r||t===f?1:Z(t)))<0?0:t,n):[]},o.takeRightWhile=function(e,t){return e&&e.length?Wr(e,N(t,3),!1,!0):[]},o.takeWhile=function(e,t){return e&&e.length?Wr(e,N(t,3)):[]},o.tap=function(e,t){return t(e),e},o.throttle=function(e,t,r){var n=!0,u=!0;if(typeof e!="function")throw new Je(G);return pe(r)&&(n="leading"in r?!!r.leading:n,u="trailing"in r?!!r.trailing:u),mu(e,t,{leading:n,maxWait:t,trailing:u})},o.thru=Zr,o.toArray=wu,o.toPairs=Qu,o.toPairsIn=Yu,o.toPath=function(e){return H(e)?$(e,dt):Ue(e)?[e]:Pe(Bu(oe(e)))},o.toPlainObject=xu,o.transform=function(e,t,r){var n=H(e),u=n||Tt(e)||nr(e);if(t=N(t,4),r==null){var s=e&&e.constructor;r=u?n?new s:[]:pe(e)&&wt(s)?rr(cn(e)):{}}return(u?K:ft)(e,function(l,g,p){return t(r,l,g,p)}),r},o.unary=function(e){return vu(e,1)},o.union=Uc,o.unionBy=Hc,o.unionWith=Zc,o.uniq=function(e){return e&&e.length?At(e):[]},o.uniqBy=function(e,t){return e&&e.length?At(e,N(t,2)):[]},o.uniqWith=function(e,t){return t=typeof t=="function"?t:f,e&&e.length?At(e,f,t):[]},o.unset=function(e,t){return e==null||Qn(e,t)},o.unzip=li,o.unzipWith=du,o.update=function(e,t,r){return e==null?e:jo(e,t,ei(r))},o.updateWith=function(e,t,r,n){return n=typeof n=="function"?n:f,e==null?e:jo(e,t,ei(r),n)},o.values=Qt,o.valuesIn=function(e){return e==null?[]:Ot(e,We(e))},o.without=Gc,o.words=Su,o.wrap=function(e,t){return Ti(ei(t),e)},o.xor=Xc,o.xorBy=Qc,o.xorWith=Yc,o.zip=Jc,o.zipObject=function(e,t){return Ro(e||[],t||[],dr)},o.zipObjectDeep=function(e,t){return Ro(e||[],t||[],vr)},o.zipWith=es,o.entries=Qu,o.entriesIn=Yu,o.extend=Gu,o.extendWith=vn,_i(o,o),o.add=Zs,o.attempt=Ju,o.camelCase=Ts,o.capitalize=Iu,o.ceil=Gs,o.clamp=function(e,t,r){return r===f&&(r=t,t=f),r!==f&&(r=(r=Ye(r))==r?r:0),t!==f&&(t=(t=Ye(t))==t?t:0),Ft(Ye(e),t,r)},o.clone=function(e){return Ge(e,4)},o.cloneDeep=function(e){return Ge(e,5)},o.cloneDeepWith=function(e,t){return Ge(e,5,t=typeof t=="function"?t:f)},o.cloneWith=function(e,t){return Ge(e,4,t=typeof t=="function"?t:f)},o.conformsTo=function(e,t){return t==null||vo(e,t,Se(t))},o.deburr=Au,o.defaultTo=function(e,t){return e==null||e!=e?t:e},o.divide=Xs,o.endsWith=function(e,t,r){e=oe(e),t=$e(t);var n=e.length,u=r=r===f?n:Ft(Z(r),0,n);return(r-=t.length)>=0&&e.slice(r,u)==t},o.eq=at,o.escape=function(e){return(e=oe(e))&&ca.test(e)?e.replace(zi,Ga):e},o.escapeRegExp=function(e){return(e=oe(e))&&ha.test(e)?e.replace(Tn,"\\$&"):e},o.every=function(e,t,r){var n=H(e)?M:ec;return r&&Me(e,t,r)&&(t=f),n(e,N(t,3))},o.find=ns,o.findIndex=au,o.findKey=function(e,t){return fe(e,N(t,3),ft)},o.findLast=is,o.findLastIndex=cu,o.findLastKey=function(e,t){return fe(e,N(t,3),Nn)},o.floor=Qs,o.forEach=hu,o.forEachRight=pu,o.forIn=function(e,t){return e==null?e:Ai(e,N(t,3),We)},o.forInRight=function(e,t){return e==null?e:Wu(e,N(t,3),We)},o.forOwn=function(e,t){return e&&ft(e,N(t,3))},o.forOwnRight=function(e,t){return e&&Nn(e,N(t,3))},o.get=gi,o.gt=hs,o.gte=ps,o.has=function(e,t){return e!=null&&Yo(e,t,tc)},o.hasIn=hi,o.head=fu,o.identity=Ke,o.includes=function(e,t,r,n){e=ze(e)?e:Qt(e),r=r&&!n?Z(r):0;var u=e.length;return r<0&&(r=xe(u+r,0)),Jr(e)?r<=u&&e.indexOf(t,r)>-1:!!u&&Ee(e,t,r)>-1},o.indexOf=function(e,t,r){var n=e==null?0:e.length;if(!n)return-1;var u=r==null?0:Z(r);return u<0&&(u=xe(n+u,0)),Ee(e,t,u)},o.inRange=function(e,t,r){return t=kt(t),r===f?(r=t,t=0):r=kt(r),function(n,u,s){return n>=je(u,s)&&n<xe(u,s)}(e=Ye(e),t,r)},o.invoke=Ss,o.isArguments=Nt,o.isArray=H,o.isArrayBuffer=vs,o.isArrayLike=ze,o.isArrayLikeObject=be,o.isBoolean=function(e){return e===!0||e===!1||_e(e)&&Re(e)==or},o.isBuffer=Tt,o.isDate=_s,o.isElement=function(e){return _e(e)&&e.nodeType===1&&!yr(e)},o.isEmpty=function(e){if(e==null)return!0;if(ze(e)&&(H(e)||typeof e=="string"||typeof e.splice=="function"||Tt(e)||nr(e)||Nt(e)))return!e.length;var t=Oe(e);if(t==it||t==ot)return!e.size;if(mr(e))return!$n(e).length;for(var r in e)if(ae.call(e,r))return!1;return!0},o.isEqual=function(e,t){return pr(e,t)},o.isEqualWith=function(e,t,r){var n=(r=typeof r=="function"?r:f)?r(e,t):f;return n===f?pr(e,t,f,r):!!n},o.isError=di,o.isFinite=function(e){return typeof e=="number"&&Mu(e)},o.isFunction=wt,o.isInteger=yu,o.isLength=Yr,o.isMap=Hu,o.isMatch=function(e,t){return e===t||Bn(e,t,ui(t))},o.isMatchWith=function(e,t,r){return r=typeof r=="function"?r:f,Bn(e,t,ui(t),r)},o.isNaN=function(e){return bu(e)&&e!=+e},o.isNative=function(e){if(Pc(e))throw new wi("Unsupported core-js use. Try https://npms.io/search?q=ponyfill.");return wo(e)},o.isNil=function(e){return e==null},o.isNull=function(e){return e===null},o.isNumber=bu,o.isObject=pe,o.isObjectLike=_e,o.isPlainObject=yr,o.isRegExp=ji,o.isSafeInteger=function(e){return yu(e)&&e>=-st&&e<=st},o.isSet=Zu,o.isString=Jr,o.isSymbol=Ue,o.isTypedArray=nr,o.isUndefined=function(e){return e===f},o.isWeakMap=function(e){return _e(e)&&Oe(e)==fr},o.isWeakSet=function(e){return _e(e)&&Re(e)=="[object WeakSet]"},o.join=function(e,t){return e==null?"":Cc.call(e,t)},o.kebabCase=js,o.last=Qe,o.lastIndexOf=function(e,t,r){var n=e==null?0:e.length;if(!n)return-1;var u=n;return r!==f&&(u=(u=Z(r))<0?xe(n+u,0):je(u,n-1)),t==t?function(s,l,g){for(var p=g+1;p--;)if(s[p]===l)return p;return p}(e,t,u):Te(e,et,u,!0)},o.lowerCase=Os,o.lowerFirst=Rs,o.lt=ms,o.lte=ys,o.max=function(e){return e&&e.length?Mr(e,Ke,Vn):f},o.maxBy=function(e,t){return e&&e.length?Mr(e,N(t,2),Vn):f},o.mean=function(e){return ct(e,Ke)},o.meanBy=function(e,t){return ct(e,N(t,2))},o.min=function(e){return e&&e.length?Mr(e,Ke,Un):f},o.minBy=function(e,t){return e&&e.length?Mr(e,N(t,2),Un):f},o.stubArray=yi,o.stubFalse=bi,o.stubObject=function(){return{}},o.stubString=function(){return""},o.stubTrue=function(){return!0},o.multiply=Ys,o.nth=function(e,t){return e&&e.length?Ao(e,Z(t)):f},o.noConflict=function(){return Ae._===this&&(Ae._=mc),this},o.noop=mi,o.now=pn,o.pad=function(e,t,r){e=oe(e);var n=(t=Z(t))?E(e):0;if(!t||n>=t)return e;var u=(t-n)/2;return qr(dn(u),r)+e+qr(ln(u),r)},o.padEnd=function(e,t,r){e=oe(e);var n=(t=Z(t))?E(e):0;return t&&n<t?e+qr(t-n,r):e},o.padStart=function(e,t,r){e=oe(e);var n=(t=Z(t))?E(e):0;return t&&n<t?qr(t-n,r)+e:e},o.parseInt=function(e,t,r){return r||t==null?t=0:t&&(t=+t),Sc(oe(e).replace(jn,""),t||0)},o.random=function(e,t,r){if(r&&typeof r!="boolean"&&Me(e,t,r)&&(t=r=f),r===f&&(typeof t=="boolean"?(r=t,t=f):typeof e=="boolean"&&(r=e,e=f)),e===f&&t===f?(e=0,t=1):(e=kt(e),t===f?(t=e,e=0):t=kt(t)),e>t){var n=e;e=t,t=n}if(r||e%1||t%1){var u=Fu();return je(e+u*(t-e+Ba("1e-"+((u+"").length-1))),t)}return Zn(e,t)},o.reduce=function(e,t,r){var n=H(e)?me:tt,u=arguments.length<3;return n(e,N(t,4),r,u,Lt)},o.reduceRight=function(e,t,r){var n=H(e)?Ne:tt,u=arguments.length<3;return n(e,N(t,4),r,u,zu)},o.repeat=function(e,t,r){return t=(r?Me(e,t,r):t===f)?1:Z(t),Gn(oe(e),t)},o.replace=function(){var e=arguments,t=oe(e[0]);return e.length<3?t:t.replace(e[1],e[2])},o.result=function(e,t,r){var n=-1,u=(t=St(t,e)).length;for(u||(u=1,e=f);++n<u;){var s=e==null?f:e[dt(t[n])];s===f&&(n=u,s=r),e=wt(s)?s.call(e):s}return e},o.round=Js,o.runInContext=v,o.sample=function(e){return(H(e)?ho:ic)(e)},o.size=function(e){if(e==null)return 0;if(ze(e))return Jr(e)?E(e):e.length;var t=Oe(e);return t==it||t==ot?e.size:$n(e).length},o.snakeCase=Ms,o.some=function(e,t,r){var n=H(e)?ne:ac;return r&&Me(e,t,r)&&(t=f),n(e,N(t,3))},o.sortedIndex=function(e,t){return zr(e,t)},o.sortedIndexBy=function(e,t,r){return Xn(e,t,N(r,2))},o.sortedIndexOf=function(e,t){var r=e==null?0:e.length;if(r){var n=zr(e,t);if(n<r&&at(e[n],t))return n}return-1},o.sortedLastIndex=function(e,t){return zr(e,t,!0)},o.sortedLastIndexBy=function(e,t,r){return Xn(e,t,N(r,2),!0)},o.sortedLastIndexOf=function(e,t){if(e!=null&&e.length){var r=zr(e,t,!0)-1;if(at(e[r],t))return r}return-1},o.startCase=Fs,o.startsWith=function(e,t,r){return e=oe(e),r=r==null?0:Ft(Z(r),0,e.length),t=$e(t),e.slice(r,r+t.length)==t},o.subtract=ef,o.sum=function(e){return e&&e.length?He(e,Ke):0},o.sumBy=function(e,t){return e&&e.length?He(e,N(t,2)):0},o.template=function(e,t,r){var n=o.templateSettings;r&&Me(e,t,r)&&(t=f),e=oe(e),t=vn({},t,n,Go);var u,s,l=vn({},t.imports,n.imports,Go),g=Se(l),p=Ot(l,g),y=0,b=t.interpolate||Tr,C="__p += '",L=ki((t.escape||Tr).source+"|"+b.source+"|"+(b===Wi?ka:Tr).source+"|"+(t.evaluate||Tr).source+"|$","g"),D="//# sourceURL="+(ae.call(t,"sourceURL")?(t.sourceURL+"").replace(/\s/g," "):"lodash.templateSources["+ ++Va+"]")+`
`;e.replace(L,function(A,B,j,W,te,ve){return j||(j=W),C+=e.slice(y,ve).replace(Da,_),B&&(u=!0,C+=`' +
__e(`+B+`) +
'`),te&&(s=!0,C+=`';
`+te+`;
__p += '`),j&&(C+=`' +
((__t = (`+j+`)) == null ? '' : __t) +
'`),y=ve+A.length,A}),C+=`';
`;var R=ae.call(t,"variable")&&t.variable;if(R){if(ba.test(R))throw new wi("Invalid `variable` option passed into `_.template`")}else C=`with (obj) {
`+C+`
}
`;C=(s?C.replace(ia,""):C).replace(oa,"$1").replace(ua,"$1;"),C="function("+(R||"obj")+`) {
`+(R?"":`obj || (obj = {});
`)+"var __t, __p = ''"+(u?", __e = _.escape":"")+(s?`, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
`:`;
`)+C+`return __p
}`;var x=Ju(function(){return Du(g,D+"return "+C).apply(f,p)});if(x.source=C,di(x))throw x;return x},o.times=function(e,t){if((e=Z(e))<1||e>st)return[];var r=Ct,n=je(e,Ct);t=N(t),e-=Ct;for(var u=rt(n,t);++r<e;)t(r);return u},o.toFinite=kt,o.toInteger=Z,o.toLength=ku,o.toLower=function(e){return oe(e).toLowerCase()},o.toNumber=Ye,o.toSafeInteger=function(e){return e?Ft(Z(e),-st,st):e===0?e:0},o.toString=oe,o.toUpper=function(e){return oe(e).toUpperCase()},o.trim=function(e,t,r){if((e=oe(e))&&(r||t===f))return nt(e);if(!e||!(t=$e(t)))return e;var n=S(e),u=S(t);return Et(n,a(n,u),i(n,u)+1).join("")},o.trimEnd=function(e,t,r){if((e=oe(e))&&(r||t===f))return e.slice(0,J(e)+1);if(!e||!(t=$e(t)))return e;var n=S(e);return Et(n,0,i(n,S(t))+1).join("")},o.trimStart=function(e,t,r){if((e=oe(e))&&(r||t===f))return e.replace(jn,"");if(!e||!(t=$e(t)))return e;var n=S(e);return Et(n,a(n,S(t))).join("")},o.truncate=function(e,t){var r=30,n="...";if(pe(t)){var u="separator"in t?t.separator:u;r="length"in t?Z(t.length):r,n="omission"in t?$e(t.omission):n}var s=(e=oe(e)).length;if(w(e)){var l=S(e);s=l.length}if(r>=s)return e;var g=r-E(n);if(g<1)return n;var p=l?Et(l,0,g).join(""):e.slice(0,g);if(u===f)return p+n;if(l&&(g+=p.length-g),ji(u)){if(e.slice(g).search(u)){var y,b=p;for(u.global||(u=ki(u.source,oe(Ki.exec(u))+"g")),u.lastIndex=0;y=u.exec(b);)var C=y.index;p=p.slice(0,C===f?g:C)}}else if(e.indexOf($e(u),g)!=g){var L=p.lastIndexOf(u);L>-1&&(p=p.slice(0,L))}return p+n},o.unescape=function(e){return(e=oe(e))&&aa.test(e)?e.replace(Pi,Xa):e},o.uniqueId=function(e){var t=++vc;return oe(e)+t},o.upperCase=Ps,o.upperFirst=Oi,o.each=hu,o.eachRight=pu,o.first=fu,_i(o,function(){var e={};return ft(o,function(t,r){ae.call(o.prototype,r)||(e[r]=t)}),e}(),{chain:!1}),o.VERSION="4.17.21",K(["bind","bindKey","curry","curryRight","partial","partialRight"],function(e){o[e].placeholder=o}),K(["drop","take"],function(e,t){T.prototype[e]=function(r){r=r===f?1:xe(Z(r),0);var n=this.__filtered__&&!t?new T(this):this.clone();return n.__filtered__?n.__takeCount__=je(r,n.__takeCount__):n.__views__.push({size:je(r,Ct),type:e+(n.__dir__<0?"Right":"")}),n},T.prototype[e+"Right"]=function(r){return this.reverse()[e](r).reverse()}}),K(["filter","map","takeWhile"],function(e,t){var r=t+1,n=r==1||r==3;T.prototype[e]=function(u){var s=this.clone();return s.__iteratees__.push({iteratee:N(u,3),type:r}),s.__filtered__=s.__filtered__||n,s}}),K(["head","last"],function(e,t){var r="take"+(t?"Right":"");T.prototype[e]=function(){return this[r](1).value()[0]}}),K(["initial","tail"],function(e,t){var r="drop"+(t?"":"Right");T.prototype[e]=function(){return this.__filtered__?new T(this):this[r](1)}}),T.prototype.compact=function(){return this.filter(Ke)},T.prototype.find=function(e){return this.filter(e).head()},T.prototype.findLast=function(e){return this.reverse().find(e)},T.prototype.invokeMap=X(function(e,t){return typeof e=="function"?new T(this):this.map(function(r){return hr(r,e,t)})}),T.prototype.reject=function(e){return this.filter(Qr(N(e)))},T.prototype.slice=function(e,t){e=Z(e);var r=this;return r.__filtered__&&(e>0||t<0)?new T(r):(e<0?r=r.takeRight(-e):e&&(r=r.drop(e)),t!==f&&(r=(t=Z(t))<0?r.dropRight(-t):r.take(t-e)),r)},T.prototype.takeRightWhile=function(e){return this.reverse().takeWhile(e).reverse()},T.prototype.toArray=function(){return this.take(Ct)},ft(T.prototype,function(e,t){var r=/^(?:filter|find|map|reject)|While$/.test(t),n=/^(?:head|last)$/.test(t),u=o[n?"take"+(t=="last"?"Right":""):t],s=n||/^find/.test(t);u&&(o.prototype[t]=function(){var l=this.__wrapped__,g=n?[1]:arguments,p=l instanceof T,y=g[0],b=p||H(l),C=function(B){var j=u.apply(o,re([B],g));return n&&L?j[0]:j};b&&r&&typeof y=="function"&&y.length!=1&&(p=b=!1);var L=this.__chain__,D=!!this.__actions__.length,R=s&&!L,x=p&&!D;if(!s&&b){l=x?l:new T(this);var A=e.apply(l,g);return A.__actions__.push({func:Zr,args:[C],thisArg:f}),new z(A,L)}return R&&x?e.apply(this,g):(A=this.thru(C),R?n?A.value()[0]:A.value():A)})}),K(["pop","push","shift","sort","splice","unshift"],function(e){var t=tn[e],r=/^(?:push|sort|unshift)$/.test(e)?"tap":"thru",n=/^(?:pop|shift)$/.test(e);o.prototype[e]=function(){var u=arguments;if(n&&!this.__chain__){var s=this.value();return t.apply(H(s)?s:[],u)}return this[r](function(l){return t.apply(H(l)?l:[],u)})}}),ft(T.prototype,function(e,t){var r=o[t];if(r){var n=r.name+"";ae.call(tr,n)||(tr[n]=[]),tr[n].push({name:t,func:r})}}),tr[Nr(f,2).name]=[{name:"wrapper",func:f}],T.prototype.clone=function(){var e=new T(this.__wrapped__);return e.__actions__=Pe(this.__actions__),e.__dir__=this.__dir__,e.__filtered__=this.__filtered__,e.__iteratees__=Pe(this.__iteratees__),e.__takeCount__=this.__takeCount__,e.__views__=Pe(this.__views__),e},T.prototype.reverse=function(){if(this.__filtered__){var e=new T(this);e.__dir__=-1,e.__filtered__=!0}else(e=this.clone()).__dir__*=-1;return e},T.prototype.value=function(){var e=this.__wrapped__.value(),t=this.__dir__,r=H(e),n=t<0,u=r?e.length:0,s=function(ve,V,U){for(var Vt=-1,gt=U.length;++Vt<gt;){var ir=U[Vt],Le=ir.size;switch(ir.type){case"drop":ve+=Le;break;case"dropRight":V-=Le;break;case"take":V=je(V,ve+Le);break;case"takeRight":ve=xe(ve,V-Le)}}return{start:ve,end:V}}(0,u,this.__views__),l=s.start,g=s.end,p=g-l,y=n?g:l-1,b=this.__iteratees__,C=b.length,L=0,D=je(p,this.__takeCount__);if(!r||!n&&u==p&&D==p)return Oo(e,this.__actions__);var R=[];e:for(;p--&&L<D;){for(var x=-1,A=e[y+=t];++x<C;){var B=b[x],j=B.iteratee,W=B.type,te=j(A);if(W==2)A=te;else if(!te){if(W==1)continue e;break e}}R[L++]=A}return R},o.prototype.at=ts,o.prototype.chain=function(){return gu(this)},o.prototype.commit=function(){return new z(this.value(),this.__chain__)},o.prototype.next=function(){this.__values__===f&&(this.__values__=wu(this.value()));var e=this.__index__>=this.__values__.length;return{done:e,value:e?f:this.__values__[this.__index__++]}},o.prototype.plant=function(e){for(var t,r=this;r instanceof F;){var n=uu(r);n.__index__=0,n.__values__=f,t?u.__wrapped__=n:t=n;var u=n;r=r.__wrapped__}return u.__wrapped__=e,t},o.prototype.reverse=function(){var e=this.__wrapped__;if(e instanceof T){var t=e;return this.__actions__.length&&(t=new T(this)),(t=t.reverse()).__actions__.push({func:Zr,args:[fi],thisArg:f}),new z(t,this.__chain__)}return this.thru(fi)},o.prototype.toJSON=o.prototype.valueOf=o.prototype.value=function(){return Oo(this.__wrapped__,this.__actions__)},o.prototype.first=o.prototype.head,br&&(o.prototype[br]=function(){return this}),o}();typeof define=="function"&&typeof define.amd=="object"&&define.amd?(Ae._=It,define("lodash/lodash.min",[],function(){return It})):Rt?((Rt.exports=It)._=It,Pn._=It):Ae._=It}.call(this),define("lodash",["lodash/lodash.min"],function(Y){return Y}),define("vs/language/kusto/languageFeatures",["require","exports","vscode-languageserver-types","lodash"],function(Y,d,K,Q){"use strict";Object.defineProperty(d,"__esModule",{value:!0}),d.HoverAdapter=d.FoldingAdapter=d.FormatAdapter=d.DocumentFormatAdapter=d.RenameAdapter=d.ReferenceAdapter=d.DefinitionAdapter=d.CompletionAdapter=d.ColorizationAdapter=d.DiagnosticsAdapter=void 0;var M=monaco.Uri,ie=monaco.Range,he=Kusto.Language.Editor.ClassificationKind,we=function(){function c(a,i,h,_,w){var I=this;this._monacoInstance=a,this._languageId=i,this._worker=h,this.defaults=_,this._disposables=[],this._contentListener=Object.create(null),this._configurationListener=Object.create(null),this._schemaListener=Object.create(null),this._cursorListener=Object.create(null),this._debouncedValidations=Object.create(null);var O=function(q){var E=q.getLanguageId(),S=q.uri.toString();if(E===I._languageId){var J=I.getOrCreateDebouncedValidation(q,E);I._contentListener[S]=q.onDidChangeContent(function(ee){var f=$(ee);J(f)}),I._configurationListener[S]=I.defaults.onDidChange(function(){self.setTimeout(function(){return I._doValidate(q,E,[])},0)}),I._schemaListener[S]=w(function(){self.setTimeout(function(){return I._doValidate(q,E,[])},0)})}},ue=function(q){var E=q.getId();I._cursorListener[E]||(q.onDidDispose(function(){var S;(S=I._cursorListener[E])===null||S===void 0||S.dispose(),delete I._cursorListener[E]}),I._cursorListener[E]=q.onDidChangeCursorSelection(function(S){var J=q.getModel(),ee=J.getLanguageId();if(ee===I._languageId){var f=J.getOffsetAt(S.selection.getPosition());I.getOrCreateDebouncedValidation(J,ee)([{start:f,end:f}])}}))},P=function(q){I._monacoInstance.editor.setModelMarkers(q,I._languageId,[]);var E=q.uri.toString(),S=I._contentListener[E];S&&(S.dispose(),delete I._contentListener[E]);var J=I._configurationListener[E];J&&(J.dispose(),delete I._configurationListener[E]);var ee=I._schemaListener[E];ee&&(ee.dispose(),delete I._schemaListener[E]);var f=I._debouncedValidations[E];f&&(f.cancel(),delete I._debouncedValidations[E])};this._disposables.push(this._monacoInstance.editor.onDidCreateEditor(ue)),this._disposables.push(this._monacoInstance.editor.onDidCreateModel(O)),this._disposables.push(this._monacoInstance.editor.onWillDisposeModel(P)),this._disposables.push(this._monacoInstance.editor.onDidChangeModelLanguage(function(q){P(q.model),O(q.model)})),this._disposables.push({dispose:function(){for(var q in I._contentListener)I._contentListener[q].dispose();for(var q in I._cursorListener)I._cursorListener[q].dispose();for(var q in I._debouncedValidations)I._debouncedValidations[q].cancel()}}),this._monacoInstance.editor.getModels().forEach(O),this._monacoInstance.editor.getEditors().forEach(ue)}return c.prototype.getOrCreateDebouncedValidation=function(a,i){var h=this,_=a.uri.toString();return this._debouncedValidations[_]||(this._debouncedValidations[_]=Q.debounce(function(w){return h._doValidate(a,i,w)},500)),this._debouncedValidations[_]},c.prototype.dispose=function(){this._disposables.forEach(function(a){return a&&a.dispose()}),this._disposables=[]},c.prototype._doValidate=function(a,i,h){var _=this;if(!a.isDisposed()){var w=a.uri,I=a.getVersionId();this._worker(w).then(function(O){return O.doValidation(w.toString(),h)}).then(function(O){if(_._monacoInstance.editor.getModel(w).getVersionId()===I){var ue=O.map(function(G){return Ie=typeof(ce=G).code=="number"?String(ce.code):ce.code,{severity:re(ce.severity),startLineNumber:ce.range.start.line+1,startColumn:ce.range.start.character+1,endLineNumber:ce.range.end.line+1,endColumn:ce.range.end.character+1,message:ce.message,code:Ie,source:ce.source};var ce,Ie}),P=_._monacoInstance.editor.getModel(w),q=P.getAllDecorations().filter(function(G){return G.options.className=="squiggly-error"}).map(function(G){return G.id});if(P&&P.getLanguageId()===i){var E=_.defaults.languageSettings.syntaxErrorAsMarkDown;if(E&&E.enableSyntaxErrorAsMarkDown){var S=E.header?"**"+E.header+`** 

`:"",J=(E.icon?"![]("+E.icon+")":"")+" "+S,ee=ue.map(function(G){return{range:{startLineNumber:G.startLineNumber,startColumn:G.startColumn,endLineNumber:G.endLineNumber,endColumn:G.endColumn},options:{hoverMessage:{value:J+G.message},className:"squiggly-error",zIndex:100,overviewRuler:{color:"rgb(255, 18, 18, 0.7)",position:monaco.editor.OverviewRulerLane.Right},minimap:{color:"rgb(255, 18, 18, 0.7)",position:monaco.editor.MinimapPosition.Inline}}}}),f=monaco.editor.getModelMarkers({owner:i,resource:w});f&&f.length>0&&(q=[],_._monacoInstance.editor.setModelMarkers(P,i,[])),P.deltaDecorations(q,ee)}else P.deltaDecorations(q,[]),_._monacoInstance.editor.setModelMarkers(P,i,ue)}}}).then(void 0,function(O){console.error(O)})}},c}();function $(c){return c.changes.map(function(a){return{start:a.rangeOffset,end:a.rangeOffset+a.text.length}})}function re(c){switch(c){case K.DiagnosticSeverity.Error:return monaco.MarkerSeverity.Error;case K.DiagnosticSeverity.Warning:return monaco.MarkerSeverity.Warning;case K.DiagnosticSeverity.Information:return monaco.MarkerSeverity.Info;case K.DiagnosticSeverity.Hint:return monaco.MarkerSeverity.Hint;default:return monaco.MarkerSeverity.Info}}d.DiagnosticsAdapter=we;var me={Column:"C71585",Comment:"008000",Database:"C71585",Function:"0000FF",Identifier:"000000",Keyword:"0000FF",Literal:"B22222",ScalarOperator:"0000FF",MaterializedView:"C71585",MathOperator:"000000",Command:"0000FF",Parameter:"2B91AF",PlainText:"000000",Punctuation:"000000",QueryOperator:"CC3700",QueryParameter:"CC3700",StringLiteral:"B22222",Table:"C71585",Type:"0000FF",Variable:"191970",Directive:"9400D3",ClientParameter:"b5cea8",SchemaMember:"C71585",SignatureParameter:"2B91AF",Option:"000000"},Ne={Column:"4ec9b0",Comment:"608B4E",Database:"c586c0",Function:"dcdcaa",Identifier:"d4d4d4",Keyword:"569cd6",Literal:"ce9178",ScalarOperator:"569cd6",MaterializedView:"c586c0",MathOperator:"d4d4d4",Command:"d4d4d4",Parameter:"2B91AF",PlainText:"d4d4d4",Punctuation:"d4d4d4",QueryOperator:"9cdcfe",QueryParameter:"9cdcfe",StringLiteral:"ce9178",Table:"c586c0",Type:"569cd6",Variable:"d7ba7d",Directive:"b5cea8",ClientParameter:"b5cea8",SchemaMember:"4ec9b0",SignatureParameter:"2B91AF",Option:"d4d4d4"},ne=function(){function c(a,i,h,_,w){var I,O,ue,P=this;this._monacoInstance=a,this._languageId=i,this._worker=h,this._disposables=[],this._contentListener=Object.create(null),this._configurationListener=Object.create(null),this._schemaListener=Object.create(null),this.decorations=[],I=document.getElementsByTagName("head")[0],(O=document.createElement("style")).type="text/css",O.media="screen",I.appendChild(O),O.innerHTML=(ue=he,Object.keys(ue).filter(function(S){return typeof ue[S]=="number"})).map(function(S){return{classification:S,colorLight:me[S],colorDark:Ne[S]}}).map(function(S){return".vs ."+S.classification+" {color: #"+S.colorLight+";} .vs-dark ."+S.classification+" {color: #"+S.colorDark+";}"}).join(`
`);var q=function(S){var J=S.getLanguageId();if(J===P._languageId){var ee=Q.debounce(function(f){return P._doColorization(S,J,f)},500);P._contentListener[S.uri.toString()]=S.onDidChangeContent(function(f){var G=$(f);ee(G)}),P._configurationListener[S.uri.toString()]=_.onDidChange(function(){self.setTimeout(function(){return P._doColorization(S,J,[])},0)}),P._schemaListener[S.uri.toString()]=w(function(){self.setTimeout(function(){return P._doColorization(S,J,[])},0)})}},E=function(S){S.deltaDecorations(P.decorations,[]);var J=S.uri.toString(),ee=P._contentListener[J];ee&&(ee.dispose(),delete P._contentListener[J]);var f=P._configurationListener[J];f&&(f.dispose(),delete P._configurationListener[J]);var G=P._configurationListener[J];G&&(G.dispose(),delete P._schemaListener[J])};this._disposables.push(this._monacoInstance.editor.onDidCreateModel(q)),this._disposables.push(this._monacoInstance.editor.onWillDisposeModel(E)),this._disposables.push(this._monacoInstance.editor.onDidChangeModelLanguage(function(S){E(S.model),q(S.model)})),this._disposables.push({dispose:function(){for(var S in P._contentListener)P._contentListener[S].dispose()}}),this._monacoInstance.editor.getModels().forEach(q)}return c.prototype.dispose=function(){this._disposables.forEach(function(a){return a&&a.dispose()}),this._disposables=[]},c.prototype._rangeDoesNotIntersectAny=function(a,i){return i.every(function(h){return a.startLineNumber>h.lastImpactedLine||a.endLineNumber<h.firstImpactedLine})},c.prototype._doColorization=function(a,i,h){var _=this;if(!a.isDisposed()){var w=a.uri,I=a.getVersionId();this._worker(w).then(function(O){return O.doColorization(w.toString(),h)}).then(function(O){if(_._monacoInstance.editor.getModel(a.uri).getVersionId()===I){var ue=O.map(function(E){var S=E.classifications.map(function(f){return function(G,ce){var Ie=G.getPositionAt(ce.start),qe=G.getPositionAt(ce.start+ce.length),st=new ie(Ie.lineNumber,Ie.column,qe.lineNumber,qe.column),Bt=he.$names[ce.kind];return{range:st,options:{inlineClassName:Bt,stickiness:monaco.editor.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges}}}(a,f)}).filter(function(f){return f.options.inlineClassName!=="PlainText"&&f.options.inlineClassName!="Identifier"}),J=a.getPositionAt(E.absoluteStart).lineNumber,ee=a.getPositionAt(E.absoluteEnd);return{decorations:S,firstImpactedLine:J,lastImpactedLine:ee.column==1&&ee.lineNumber>1?ee.lineNumber-1:ee.lineNumber}}),P=ue.map(function(E){return a.getLinesDecorations(E.firstImpactedLine,E.lastImpactedLine).filter(function(S){return me[S.options.inlineClassName]}).map(function(S){return S.id})}).reduce(function(E,S){return E.concat(S)},[]),q=ue.reduce(function(E,S){return E.concat(S.decorations)},[]);a&&a.getLanguageId()===i&&(_.decorations=a.deltaDecorations(P,q))}}).then(void 0,function(O){console.error(O)})}},c}();function ye(c){if(c)return{character:c.column-1,line:c.lineNumber-1}}function fe(c){if(c)return new ie(c.start.line+1,c.start.character+1,c.end.line+1,c.end.character+1)}function Te(c){var a=monaco.languages.CompletionItemKind;switch(c){case K.CompletionItemKind.Text:return a.Text;case K.CompletionItemKind.Method:return a.Method;case K.CompletionItemKind.Function:return a.Function;case K.CompletionItemKind.Constructor:return a.Constructor;case K.CompletionItemKind.Field:return a.Field;case K.CompletionItemKind.Variable:return a.Variable;case K.CompletionItemKind.Class:return a.Class;case K.CompletionItemKind.Interface:return a.Interface;case K.CompletionItemKind.Module:return a.Module;case K.CompletionItemKind.Property:return a.Property;case K.CompletionItemKind.Unit:return a.Unit;case K.CompletionItemKind.Value:return a.Value;case K.CompletionItemKind.Enum:return a.Enum;case K.CompletionItemKind.Keyword:return a.Keyword;case K.CompletionItemKind.Snippet:return a.Snippet;case K.CompletionItemKind.Color:return a.Color;case K.CompletionItemKind.File:return a.File;case K.CompletionItemKind.Reference:return a.Reference}return a.Property}function Ee(c){if(c)return{range:fe(c.range),text:c.newText}}d.ColorizationAdapter=ne;var Ve=function(){function c(a,i){this._worker=a,this.languageSettings=i}return Object.defineProperty(c.prototype,"triggerCharacters",{get:function(){return[" "]},enumerable:!1,configurable:!0}),c.prototype.provideCompletionItems=function(a,i,h,_){var w=a.getWordUntilPosition(i),I=new ie(i.lineNumber,w.startColumn,i.lineNumber,w.endColumn),O=a.uri,ue=this.languageSettings.onDidProvideCompletionItems;return this._worker(O).then(function(P){return P.doComplete(O.toString(),ye(i))}).then(function(P){return ue?ue(P):P}).then(function(P){if(P){var q=P.items.map(function(E){var S,J,ee={label:E.label,insertText:E.insertText,sortText:E.sortText,filterText:E.filterText,documentation:(J=(S=E.documentation)===null||S===void 0?void 0:S.value,{value:J,isTrusted:!0,uris:new Proxy({},{get:function(f,G,ce){var Ie=G.toString().replace(".md",""),qe=Ie.startsWith("https")?Ie:"https://learn.microsoft.com/azure/data-explorer/kusto/query/"+Ie;return monaco.Uri.parse(qe)}})}),detail:E.detail,range:I,kind:Te(E.kind)};return E.textEdit&&(ee.range=fe(E.textEdit.range),ee.insertText=E.textEdit.newText),E.insertTextFormat===K.InsertTextFormat.Snippet&&(ee.insertTextRules=monaco.languages.CompletionItemInsertTextRule.InsertAsSnippet),ee});return{isIncomplete:P.isIncomplete,suggestions:q}}})},c}();function et(c){return typeof c=="string"?{value:c}:(a=c)&&typeof a=="object"&&typeof a.kind=="string"?c.kind==="plaintext"?{value:c.value.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}:{value:c.value}:{value:"```"+c.value+`
`+c.value+"\n```\n"};var a}function ct(c){if(c)return Array.isArray(c)?c.map(et):[et(c)]}function Ce(c){return{uri:M.parse(c.uri),range:fe(c.range)}}d.CompletionAdapter=Ve;var Fe=function(){function c(a){this._worker=a}return c.prototype.provideDefinition=function(a,i,h){var _=a.uri;return this._worker(_).then(function(w){return w.findDefinition(_.toString(),ye(i))}).then(function(w){if(w&&w.length!=0)return[Ce(w[0])]})},c}();d.DefinitionAdapter=Fe;var tt=function(){function c(a){this._worker=a}return c.prototype.provideReferences=function(a,i,h,_){var w=a.uri;return this._worker(w).then(function(I){return I.findReferences(w.toString(),ye(i))}).then(function(I){if(I)return I.map(Ce)})},c}();d.ReferenceAdapter=tt;var He=function(){function c(a){this._worker=a}return c.prototype.provideRenameEdits=function(a,i,h,_){var w=a.uri;return this._worker(w).then(function(I){return I.doRename(w.toString(),ye(i),h)}).then(function(I){return function(O){if(O&&O.changes){var ue=[];for(var P in O.changes)for(var q=M.parse(P),E=0,S=O.changes[P];E<S.length;E++){var J=S[E];ue.push({resource:q,textEdit:{range:fe(J.range),text:J.newText},versionId:void 0})}return{edits:ue}}}(I)})},c}();d.RenameAdapter=He;var rt=function(){function c(a){this._worker=a}return c.prototype.provideDocumentFormattingEdits=function(a,i,h){var _=a.uri;return this._worker(_).then(function(w){return w.doDocumentFormat(_.toString()).then(function(I){return I.map(function(O){return Ee(O)})})})},c}();d.DocumentFormatAdapter=rt;var nt=function(){function c(a){this._worker=a}return c.prototype.provideDocumentRangeFormattingEdits=function(a,i,h,_){var w=a.uri;return this._worker(w).then(function(I){return I.doRangeFormat(w.toString(),function(O){if(O)return{start:ye(O.getStartPosition()),end:ye(O.getEndPosition())}}(i)).then(function(O){return O.map(function(ue){return Ee(ue)})})})},c}();d.FormatAdapter=nt;var m=function(){function c(a){this._worker=a}return c.prototype.provideFoldingRanges=function(a,i,h){var _=a.uri;return this._worker(_).then(function(w){return w.doFolding(_.toString()).then(function(I){return I.map(function(O){return function(ue){return{start:ue.startLine+1,end:ue.endLine+1,kind:monaco.languages.FoldingRangeKind.Region}}(O)})})})},c}();d.FoldingAdapter=m;var Ot=function(){function c(a){this._worker=a}return c.prototype.provideHover=function(a,i,h){var _=a.uri;return this._worker(_).then(function(w){return w.doHover(_.toString(),ye(i))}).then(function(w){if(w)return{range:fe(w.range),contents:ct(w.contents)}})},c}();d.HoverAdapter=Ot});var __assign=this&&this.__assign||function(){return(__assign=Object.assign||function(Y){for(var d,K=1,Q=arguments.length;K<Q;K++)for(var M in d=arguments[K])Object.prototype.hasOwnProperty.call(d,M)&&(Y[M]=d[M]);return Y}).apply(this,arguments)};define("vs/language/kusto/kustoMode",["require","exports","./workerManager","./languageService/kustoMonarchLanguageDefinition","./languageFeatures"],function(Y,d,K,Q,M){"use strict";var ie,he;Object.defineProperty(d,"__esModule",{value:!0}),d.getKustoWorker=d.setupMode=void 0;var we=new Promise(function($,re){he=$});d.setupMode=function($,re){var me,Ne=new monaco.Emitter,ne=[],ye=new K.WorkerManager(re,$);ne.push(ye);var fe=function(Te){for(var Ee=[],Ve=1;Ve<arguments.length;Ve++)Ee[Ve-1]=arguments[Ve];var et=function(Ce,Fe,tt){Fe.setSchema(Ce).then(function(){Ne.fire(Ce)})},ct=ye.getLanguageServiceWorker.apply(ye,[Te].concat(Ee));return ct.then(function(Ce){return __assign(__assign({},Ce),{setSchema:function(Fe){return et(Fe,Ce)},setSchemaFromShowSchema:function(Fe,tt,He,rt){Ce.normalizeSchema(Fe,tt,He).then(function(nt){return rt?__assign(__assign({},nt),{globalParameters:rt}):nt}).then(function(nt){return et(nt,Ce)})}})})};return ne.push(re.languages.registerCompletionItemProvider("kusto",new M.CompletionAdapter(fe,$.languageSettings))),$.languageSettings.useTokenColorization&&(me=re.languages.setMonarchTokensProvider("kusto",Q.KustoLanguageDefinition)),$.onDidChange(function(Te){Te.languageSettings.useTokenColorization||me===void 0||(me.dispose(),me=void 0),Te.languageSettings.useTokenColorization&&me==null&&(me=re.languages.setMonarchTokensProvider("kusto",Q.KustoLanguageDefinition))}),ne.push(new M.DiagnosticsAdapter(re,"kusto",fe,$,Ne.event)),ne.push(new M.ColorizationAdapter(re,"kusto",fe,$,Ne.event)),ne.push(re.languages.registerDocumentRangeFormattingEditProvider("kusto",new M.FormatAdapter(fe))),ne.push(re.languages.registerFoldingRangeProvider("kusto",new M.FoldingAdapter(fe))),ne.push(re.languages.registerDefinitionProvider("kusto",new M.DefinitionAdapter(fe))),ne.push(re.languages.registerRenameProvider("kusto",new M.RenameAdapter(fe))),ne.push(re.languages.registerReferenceProvider("kusto",new M.ReferenceAdapter(fe))),$.languageSettings.enableHover&&ne.push(re.languages.registerHoverProvider("kusto",new M.HoverAdapter(fe))),re.languages.registerDocumentFormattingEditProvider("kusto",new M.DocumentFormatAdapter(fe)),ie=fe,he(fe),re.languages.setLanguageConfiguration("kusto",{folding:{offSide:!1,markers:{start:/^\s*[\r\n]/gm,end:/^\s*[\r\n]/gm}},comments:{lineComment:"//",blockComment:null}}),ie},d.getKustoWorker=function(){return we.then(function(){return ie})}});

//# sourceMappingURL=kustoMode.js.map